/* indicator.c generated by valac 0.56.17, the Vala compiler
 * generated from indicator.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2015-2023 Takao Fujiwara <takao.fujiwara1@gmail.com>
 * Copyright(c) 2015 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */
/* This class extends AppIndicator because
 * AppIndicator misses "Activate" dbus method in the definition
 * for left click on the indicator.
 */
/* I have no idea to exempt this file to make ibus_ui_gtk3_vala.stamp*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <ibus.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <libdbusmenu-glib/client.h>
#include <libdbusmenu-glib/dbusmenu-glib.h>
#include <libdbusmenu-glib/enum-types.h>
#include <libdbusmenu-glib/menuitem-proxy.h>
#include <libdbusmenu-glib/menuitem.h>
#include <libdbusmenu-glib/server.h>
#include <libdbusmenu-glib/types.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <cairo-gobject.h>
#include <libdbusmenu-gtk/client.h>
#include <libdbusmenu-gtk/dbusmenu-gtk.h>
#include <libdbusmenu-gtk/menu.h>
#include <libdbusmenu-gtk/menuitem.h>
#include <libdbusmenu-gtk/parser.h>

#define INDICATOR_DEFAULT_ITEM_PATH "/org/ayatana/NotificationItem"
#define INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE "org.kde.StatusNotifierItem"
#define INDICATOR_NOTIFICATION_WATCHER_DBUS_IFACE "org.kde.StatusNotifierWatcher"
#define INDICATOR_NOTIFICATION_WATCHER_DBUS_ADDR "org.kde.StatusNotifierWatcher"
#define INDICATOR_NOTIFICATION_WATCHER_DBUS_OBJ "/StatusNotifierWatcher"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_INDICATOR (indicator_get_type ())
#define INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDICATOR, Indicator))
#define INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INDICATOR, IndicatorClass))
#define IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDICATOR))
#define IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INDICATOR))
#define INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INDICATOR, IndicatorClass))

typedef struct _Indicator Indicator;
typedef struct _IndicatorClass IndicatorClass;
typedef struct _IndicatorPrivate IndicatorPrivate;
enum  {
	INDICATOR_0_PROPERTY,
	INDICATOR_ID_PROPERTY,
	INDICATOR_CATEGORY_S_PROPERTY,
	INDICATOR_STATUS_S_PROPERTY,
	INDICATOR_ICON_NAME_PROPERTY,
	INDICATOR_ICON_DESC_PROPERTY,
	INDICATOR_ATTENTION_ICON_NAME_PROPERTY,
	INDICATOR_ATTENTION_ICON_DESC_PROPERTY,
	INDICATOR_TITLE_PROPERTY,
	INDICATOR_ICON_THEME_PATH_PROPERTY,
	INDICATOR_CONNECTED_PROPERTY,
	INDICATOR_LABEL_S_PROPERTY,
	INDICATOR_LABEL_GUIDE_S_PROPERTY,
	INDICATOR_ORDERING_INDEX_PROPERTY,
	INDICATOR_ICON_VECTOR_PROPERTY,
	INDICATOR_NUM_PROPERTIES
};
static GParamSpec* indicator_properties[INDICATOR_NUM_PROPERTIES];
typedef enum  {
	INDICATOR_CATEGORY_APPLICATION_STATUS,
	INDICATOR_CATEGORY_COMMUNICATIONS,
	INDICATOR_CATEGORY_SYSTEM_SERVICES,
	INDICATOR_CATEGORY_HARDWARE,
	INDICATOR_CATEGORY_OTHER
} IndicatorCategory;

#define INDICATOR_TYPE_CATEGORY (indicator_category_get_type ())
typedef enum  {
	INDICATOR_STATUS_PASSIVE,
	INDICATOR_STATUS_ACTIVE,
	INDICATOR_STATUS_ATTENTION
} IndicatorStatus;

#define INDICATOR_TYPE_STATUS (indicator_status_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_dbus_node_info_unref0(var) ((var == NULL) ? NULL : (var = (g_dbus_node_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
enum  {
	INDICATOR_CONTEXT_MENU_SIGNAL,
	INDICATOR_ACTIVATE_SIGNAL,
	INDICATOR_SECONDARY_ACTIVATE_SIGNAL,
	INDICATOR_REGISTERED_STATUS_NOTIFIER_ITEM_SIGNAL,
	INDICATOR_NUM_SIGNALS
};
static guint indicator_signals[INDICATOR_NUM_SIGNALS] = {0};

struct _Indicator {
	IBusService parent_instance;
	IndicatorPrivate * priv;
};

struct _IndicatorClass {
	IBusServiceClass parent_class;
};

struct _IndicatorPrivate {
	gchar* _id;
	gchar* _category_s;
	gchar* _status_s;
	gchar* _icon_name;
	gchar* _icon_desc;
	gchar* _attention_icon_name;
	gchar* _attention_icon_desc;
	gchar* _title;
	gchar* _icon_theme_path;
	gboolean _connected;
	gchar* _label_s;
	gchar* _label_guide_s;
	guint32 _ordering_index;
	GVariant* _icon_vector;
	GDBusNodeInfo* m_watcher_node_info;
	GDBusInterfaceInfo* m_watcher_interface_info;
	gboolean m_registered;
	GDBusProxy* m_proxy;
	gint m_context_menu_x;
	gint m_context_menu_y;
	gint m_activate_menu_x;
	gint m_activate_menu_y;
	GdkWindow* m_indicator_window;
	GtkMenu* m_menu;
	DbusmenuServer* m_dbusmenu_server;
};

VALA_EXTERN gchar* _notification_item;
VALA_EXTERN gchar* _notification_watcher;
static gint Indicator_private_offset;
static gpointer indicator_parent_class = NULL;

VALA_EXTERN GType indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indicator, g_object_unref)
VALA_EXTERN GType indicator_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* indicator_category_to_nick (IndicatorCategory self);
VALA_EXTERN GType indicator_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* indicator_status_to_nick (IndicatorStatus self);
VALA_EXTERN Indicator* indicator_new (const gchar* id,
                          IndicatorCategory category);
VALA_EXTERN Indicator* indicator_construct (GType object_type,
                                const gchar* id,
                                IndicatorCategory category);
VALA_EXTERN void indicator_set_status_s (Indicator* self,
                             const gchar* value);
VALA_EXTERN void indicator_set_icon_name (Indicator* self,
                              const gchar* value);
VALA_EXTERN void indicator_set_icon_desc (Indicator* self,
                              const gchar* value);
VALA_EXTERN void indicator_set_title (Indicator* self,
                          const gchar* value);
VALA_EXTERN void indicator_set_icon_theme_path (Indicator* self,
                                    const gchar* value);
VALA_EXTERN void indicator_set_attention_icon_name (Indicator* self,
                                        const gchar* value);
VALA_EXTERN void indicator_set_attention_icon_desc (Indicator* self,
                                        const gchar* value);
VALA_EXTERN void indicator_set_label_s (Indicator* self,
                            const gchar* value);
VALA_EXTERN void indicator_set_label_guide_s (Indicator* self,
                                  const gchar* value);
static void indicator_name_appeared_handler (Indicator* self,
                                      GDBusConnection* connection,
                                      const gchar* name,
                                      const gchar* name_owner);
static void _indicator_name_appeared_handler_gbus_name_appeared_callback (GDBusConnection* connection,
                                                                   const gchar* name,
                                                                   const gchar* name_owner,
                                                                   gpointer self);
static void indicator_name_vanished_handler (Indicator* self,
                                      GDBusConnection* connection,
                                      const gchar* name);
static void _indicator_name_vanished_handler_gbus_name_vanished_callback (GDBusConnection* connection,
                                                                   const gchar* name,
                                                                   gpointer self);
static void __lambda7_ (Indicator* self,
                 GObject* obj,
                 GAsyncResult* res);
static void indicator_check_connect (Indicator* self);
static void ___lambda7__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void __lambda4_ (Indicator* self,
                 GObject* obj,
                 GAsyncResult* res);
static void indicator_bus_watcher_ready (Indicator* self,
                                  GObject* obj,
                                  GAsyncResult* res);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void ___lambda5_ (Indicator* self,
                  GObject* obj,
                  GParamSpec* pspec);
static void ____lambda5__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda6_ (Indicator* self,
                 GObject* p_obj,
                 GAsyncResult* p_res);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void _indicator_context_menu_cb (Indicator* self,
                                 GDBusConnection* connection,
                                 GVariant* parameters,
                                 GDBusMethodInvocation* invocation);
static GdkWindow* indicator_query_gdk_window (Indicator* self);
static void _indicator_activate_menu_cb (Indicator* self,
                                  GDBusConnection* connection,
                                  GVariant* parameters,
                                  GDBusMethodInvocation* invocation);
VALA_EXTERN GdkX11Display* binding_common_get_xdisplay (void);
static GVariant* _indicator_get_id (Indicator* self,
                             GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_id (Indicator* self);
static GVariant* _indicator_get_category (Indicator* self,
                                   GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_category_s (Indicator* self);
static GVariant* _indicator_get_status (Indicator* self,
                                 GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_status_s (Indicator* self);
static GVariant* _indicator_get_icon_name (Indicator* self,
                                    GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_icon_name (Indicator* self);
static GVariant* _indicator_get_icon_vector (Indicator* self,
                                      GDBusConnection* connection);
VALA_EXTERN GVariant* indicator_get_icon_vector (Indicator* self);
static GVariant* _indicator_get_icon_desc (Indicator* self,
                                    GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_icon_desc (Indicator* self);
static GVariant* _indicator_get_attention_icon_name (Indicator* self,
                                              GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_attention_icon_name (Indicator* self);
static GVariant* _indicator_get_attention_icon_desc (Indicator* self,
                                              GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_attention_icon_desc (Indicator* self);
static GVariant* _indicator_get_title (Indicator* self,
                                GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_title (Indicator* self);
static GVariant* _indicator_get_icon_theme_path (Indicator* self,
                                          GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_icon_theme_path (Indicator* self);
static GVariant* _indicator_get_menu (Indicator* self,
                               GDBusConnection* connection);
static GVariant* _indicator_get_xayatana_label (Indicator* self,
                                         GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_label_s (Indicator* self);
static GVariant* _indicator_get_xayatana_label_guide (Indicator* self,
                                               GDBusConnection* connection);
VALA_EXTERN const gchar* indicator_get_label_guide_s (Indicator* self);
static GVariant* _indicator_get_xayatana_ordering_index (Indicator* self,
                                                  GDBusConnection* connection);
VALA_EXTERN guint32 indicator_get_ordering_index (Indicator* self);
static void indicator_real_service_method_call (IBusService* base,
                                         GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* method_name,
                                         GVariant* parameters,
                                         GDBusMethodInvocation* invocation);
static GVariant* indicator_real_service_get_property (IBusService* base,
                                               GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* property_name,
                                               GError** error);
static gboolean indicator_real_service_set_property (IBusService* base,
                                              GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GVariant* value,
                                              GError** error);
VALA_EXTERN void indicator_set_status (Indicator* self,
                           IndicatorStatus status);
VALA_EXTERN void indicator_set_icon_full (Indicator* self,
                              const gchar* icon_name,
                              const gchar* icon_desc);
VALA_EXTERN void indicator_set_icon_vector (Indicator* self,
                                GVariant* value);
VALA_EXTERN void indicator_set_cairo_image_surface_full (Indicator* self,
                                             cairo_surface_t* image,
                                             const gchar* icon_desc);
VALA_EXTERN void indicator_set_menu (Indicator* self,
                         GtkMenu* menu);
VALA_EXTERN void indicator_position_context_menu (Indicator* self,
                                      GtkMenu* menu,
                                      gint* x,
                                      gint* y,
                                      gboolean* push_in);
VALA_EXTERN void indicator_position_activate_menu (Indicator* self,
                                       GtkMenu* menu,
                                       gint* x,
                                       gint* y,
                                       gboolean* push_in);
VALA_EXTERN void indicator_unregister_connection (Indicator* self);
static void indicator_set_id (Indicator* self,
                       const gchar* value);
static void indicator_set_category_s (Indicator* self,
                               const gchar* value);
VALA_EXTERN gboolean indicator_get_connected (Indicator* self);
VALA_EXTERN void indicator_set_connected (Indicator* self,
                              gboolean value);
VALA_EXTERN void indicator_set_ordering_index (Indicator* self,
                                   guint32 value);
static void g_cclosure_user_marshal_VOID__INT_INT_OBJECT_UINT_UINT (GClosure * closure,
                                                             GValue * return_value,
                                                             guint n_param_values,
                                                             const GValue * param_values,
                                                             gpointer invocation_hint,
                                                             gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT_OBJECT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void indicator_finalize (GObject * obj);
static GType indicator_get_type_once (void);
static void _vala_indicator_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_indicator_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
indicator_get_instance_private (Indicator* self)
{
	return G_STRUCT_MEMBER_P (self, Indicator_private_offset);
}

gchar*
indicator_category_to_nick (IndicatorCategory self)
{
	gchar* result;
#line 59 "indicator.vala"
	switch (self) {
#line 59 "indicator.vala"
		case INDICATOR_CATEGORY_APPLICATION_STATUS:
#line 401 "indicator.c"
		{
			gchar* _tmp0_;
#line 60 "indicator.vala"
			_tmp0_ = g_strdup ("ApplicationStatus");
#line 60 "indicator.vala"
			result = _tmp0_;
#line 60 "indicator.vala"
			return result;
#line 410 "indicator.c"
		}
#line 59 "indicator.vala"
		case INDICATOR_CATEGORY_COMMUNICATIONS:
#line 414 "indicator.c"
		{
			gchar* _tmp1_;
#line 61 "indicator.vala"
			_tmp1_ = g_strdup ("Communications");
#line 61 "indicator.vala"
			result = _tmp1_;
#line 61 "indicator.vala"
			return result;
#line 423 "indicator.c"
		}
#line 59 "indicator.vala"
		case INDICATOR_CATEGORY_SYSTEM_SERVICES:
#line 427 "indicator.c"
		{
			gchar* _tmp2_;
#line 62 "indicator.vala"
			_tmp2_ = g_strdup ("SystemServices");
#line 62 "indicator.vala"
			result = _tmp2_;
#line 62 "indicator.vala"
			return result;
#line 436 "indicator.c"
		}
#line 59 "indicator.vala"
		case INDICATOR_CATEGORY_HARDWARE:
#line 440 "indicator.c"
		{
			gchar* _tmp3_;
#line 63 "indicator.vala"
			_tmp3_ = g_strdup ("Hardware");
#line 63 "indicator.vala"
			result = _tmp3_;
#line 63 "indicator.vala"
			return result;
#line 449 "indicator.c"
		}
#line 59 "indicator.vala"
		case INDICATOR_CATEGORY_OTHER:
#line 453 "indicator.c"
		{
			gchar* _tmp4_;
#line 64 "indicator.vala"
			_tmp4_ = g_strdup ("Other");
#line 64 "indicator.vala"
			result = _tmp4_;
#line 64 "indicator.vala"
			return result;
#line 462 "indicator.c"
		}
		default:
		{
#line 65 "indicator.vala"
			g_assert_not_reached ();
#line 468 "indicator.c"
		}
	}
}

static GType
indicator_category_get_type_once (void)
{
	static const GEnumValue values[] = {{INDICATOR_CATEGORY_APPLICATION_STATUS, "INDICATOR_CATEGORY_APPLICATION_STATUS", "application-status"}, {INDICATOR_CATEGORY_COMMUNICATIONS, "INDICATOR_CATEGORY_COMMUNICATIONS", "communications"}, {INDICATOR_CATEGORY_SYSTEM_SERVICES, "INDICATOR_CATEGORY_SYSTEM_SERVICES", "system-services"}, {INDICATOR_CATEGORY_HARDWARE, "INDICATOR_CATEGORY_HARDWARE", "hardware"}, {INDICATOR_CATEGORY_OTHER, "INDICATOR_CATEGORY_OTHER", "other"}, {0, NULL, NULL}};
	GType indicator_category_type_id;
	indicator_category_type_id = g_enum_register_static ("IndicatorCategory", values);
	return indicator_category_type_id;
}

GType
indicator_category_get_type (void)
{
	static volatile gsize indicator_category_type_id__once = 0;
	if (g_once_init_enter (&indicator_category_type_id__once)) {
		GType indicator_category_type_id;
		indicator_category_type_id = indicator_category_get_type_once ();
		g_once_init_leave (&indicator_category_type_id__once, indicator_category_type_id);
	}
	return indicator_category_type_id__once;
}

gchar*
indicator_status_to_nick (IndicatorStatus self)
{
	gchar* result;
#line 76 "indicator.vala"
	switch (self) {
#line 76 "indicator.vala"
		case INDICATOR_STATUS_PASSIVE:
#line 502 "indicator.c"
		{
			gchar* _tmp0_;
#line 77 "indicator.vala"
			_tmp0_ = g_strdup ("Passive");
#line 77 "indicator.vala"
			result = _tmp0_;
#line 77 "indicator.vala"
			return result;
#line 511 "indicator.c"
		}
#line 76 "indicator.vala"
		case INDICATOR_STATUS_ACTIVE:
#line 515 "indicator.c"
		{
			gchar* _tmp1_;
#line 78 "indicator.vala"
			_tmp1_ = g_strdup ("Active");
#line 78 "indicator.vala"
			result = _tmp1_;
#line 78 "indicator.vala"
			return result;
#line 524 "indicator.c"
		}
#line 76 "indicator.vala"
		case INDICATOR_STATUS_ATTENTION:
#line 528 "indicator.c"
		{
			gchar* _tmp2_;
#line 79 "indicator.vala"
			_tmp2_ = g_strdup ("NeedsAttention");
#line 79 "indicator.vala"
			result = _tmp2_;
#line 79 "indicator.vala"
			return result;
#line 537 "indicator.c"
		}
		default:
		{
#line 80 "indicator.vala"
			g_assert_not_reached ();
#line 543 "indicator.c"
		}
	}
}

static GType
indicator_status_get_type_once (void)
{
	static const GEnumValue values[] = {{INDICATOR_STATUS_PASSIVE, "INDICATOR_STATUS_PASSIVE", "passive"}, {INDICATOR_STATUS_ACTIVE, "INDICATOR_STATUS_ACTIVE", "active"}, {INDICATOR_STATUS_ATTENTION, "INDICATOR_STATUS_ATTENTION", "attention"}, {0, NULL, NULL}};
	GType indicator_status_type_id;
	indicator_status_type_id = g_enum_register_static ("IndicatorStatus", values);
	return indicator_status_type_id;
}

GType
indicator_status_get_type (void)
{
	static volatile gsize indicator_status_type_id__once = 0;
	if (g_once_init_enter (&indicator_status_type_id__once)) {
		GType indicator_status_type_id;
		indicator_status_type_id = indicator_status_get_type_once ();
		g_once_init_leave (&indicator_status_type_id__once, indicator_status_type_id);
	}
	return indicator_status_type_id__once;
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1422 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1423 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 1424 "glib-2.0.vapi"
	result = _result_;
#line 1424 "glib-2.0.vapi"
	return result;
#line 591 "indicator.c"
}

static void
_indicator_name_appeared_handler_gbus_name_appeared_callback (GDBusConnection* connection,
                                                              const gchar* name,
                                                              const gchar* name_owner,
                                                              gpointer self)
{
#line 142 "indicator.vala"
	indicator_name_appeared_handler ((Indicator*) self, connection, name, name_owner);
#line 602 "indicator.c"
}

static void
_indicator_name_vanished_handler_gbus_name_vanished_callback (GDBusConnection* connection,
                                                              const gchar* name,
                                                              gpointer self)
{
#line 142 "indicator.vala"
	indicator_name_vanished_handler ((Indicator*) self, connection, name);
#line 612 "indicator.c"
}

static void
__lambda7_ (Indicator* self,
            GObject* obj,
            GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 147 "indicator.vala"
	g_return_if_fail (res != NULL);
#line 623 "indicator.c"
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_;
#line 149 "indicator.vala"
		_tmp1_ = g_bus_get_finish (res, &_inner_error0_);
#line 149 "indicator.vala"
		_tmp0_ = _tmp1_;
#line 149 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "indicator.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 635 "indicator.c"
				goto __catch0_g_io_error;
			}
#line 149 "indicator.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "indicator.vala"
			g_clear_error (&_inner_error0_);
#line 149 "indicator.vala"
			return;
#line 644 "indicator.c"
		}
#line 149 "indicator.vala"
		g_object_set ((IBusService*) self, "connection", _tmp0_, NULL);
#line 150 "indicator.vala"
		indicator_check_connect (self);
#line 148 "indicator.vala"
		_g_object_unref0 (_tmp0_);
#line 652 "indicator.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 148 "indicator.vala"
		e = _inner_error0_;
#line 148 "indicator.vala"
		_inner_error0_ = NULL;
#line 152 "indicator.vala"
		_tmp2_ = e;
#line 152 "indicator.vala"
		_tmp3_ = _tmp2_->message;
#line 152 "indicator.vala"
		g_warning ("indicator.vala:152: Failed to get the session bus: %s", _tmp3_);
#line 148 "indicator.vala"
		_g_error_free0 (e);
#line 672 "indicator.c"
	}
	__finally0:
#line 148 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 148 "indicator.vala"
		return;
#line 683 "indicator.c"
	}
}

static void
___lambda7__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 147 "indicator.vala"
	__lambda7_ ((Indicator*) self, source_object, res);
#line 147 "indicator.vala"
	g_object_unref (self);
#line 696 "indicator.c"
}

Indicator*
indicator_construct (GType object_type,
                     const gchar* id,
                     IndicatorCategory category)
{
	Indicator * self = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gint n = 0;
	const gchar* _tmp8_;
	GDBusNodeInfo* _tmp17_;
	GDBusInterfaceInfo* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 108 "indicator.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 110 "indicator.vala"
	_tmp0_ = g_strconcat (INDICATOR_DEFAULT_ITEM_PATH "/", id, NULL);
#line 110 "indicator.vala"
	path = _tmp0_;
#line 111 "indicator.vala"
	_tmp1_ = path;
#line 111 "indicator.vala"
	_tmp2_ = string_delimit (_tmp1_, "-", '_');
#line 111 "indicator.vala"
	_g_free0 (path);
#line 111 "indicator.vala"
	path = _tmp2_;
#line 116 "indicator.vala"
	_tmp3_ = path;
#line 116 "indicator.vala"
	_tmp4_ = indicator_category_to_nick (category);
#line 116 "indicator.vala"
	_tmp5_ = _tmp4_;
#line 116 "indicator.vala"
	self = (Indicator*) g_object_new (object_type, "object-path", _tmp3_, "id", id, "category-s", _tmp5_, NULL);
#line 116 "indicator.vala"
	_g_free0 (_tmp5_);
#line 119 "indicator.vala"
	_tmp6_ = indicator_status_to_nick (INDICATOR_STATUS_PASSIVE);
#line 119 "indicator.vala"
	_tmp7_ = _tmp6_;
#line 119 "indicator.vala"
	indicator_set_status_s (self, _tmp7_);
#line 119 "indicator.vala"
	_g_free0 (_tmp7_);
#line 120 "indicator.vala"
	indicator_set_icon_name (self, "ibus");
#line 121 "indicator.vala"
	indicator_set_icon_desc (self, "");
#line 122 "indicator.vala"
	indicator_set_title (self, "");
#line 123 "indicator.vala"
	indicator_set_icon_theme_path (self, "");
#line 124 "indicator.vala"
	indicator_set_attention_icon_name (self, "");
#line 125 "indicator.vala"
	indicator_set_attention_icon_desc (self, "");
#line 126 "indicator.vala"
	indicator_set_label_s (self, "");
#line 127 "indicator.vala"
	indicator_set_label_guide_s (self, "");
#line 128 "indicator.vala"
	n = ibus_service_class_free_interfaces (G_TYPE_INSTANCE_GET_CLASS (self, ibus_service_get_type (), IBusServiceClass), 0);
#line 129 "indicator.vala"
	ibus_service_class_free_interfaces (G_TYPE_INSTANCE_GET_CLASS (self, ibus_service_get_type (), IBusServiceClass), -n);
#line 130 "indicator.vala"
	_tmp8_ = _notification_item;
#line 130 "indicator.vala"
	ibus_service_class_add_interfaces (G_TYPE_INSTANCE_GET_CLASS (self, ibus_service_get_type (), IBusServiceClass), _tmp8_);
#line 775 "indicator.c"
	{
		GDBusNodeInfo* _tmp9_ = NULL;
		const gchar* _tmp10_;
		GDBusNodeInfo* _tmp11_;
		GDBusNodeInfo* _tmp12_;
#line 134 "indicator.vala"
		_tmp10_ = _notification_watcher;
#line 134 "indicator.vala"
		_tmp11_ = g_dbus_node_info_new_for_xml (_tmp10_, &_inner_error0_);
#line 134 "indicator.vala"
		_tmp9_ = _tmp11_;
#line 134 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 789 "indicator.c"
			goto __catch0_g_error;
		}
#line 133 "indicator.vala"
		_tmp12_ = _tmp9_;
#line 133 "indicator.vala"
		_tmp9_ = NULL;
#line 133 "indicator.vala"
		_g_dbus_node_info_unref0 (self->priv->m_watcher_node_info);
#line 133 "indicator.vala"
		self->priv->m_watcher_node_info = _tmp12_;
#line 132 "indicator.vala"
		_g_dbus_node_info_unref0 (_tmp9_);
#line 802 "indicator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 132 "indicator.vala"
		e = _inner_error0_;
#line 132 "indicator.vala"
		_inner_error0_ = NULL;
#line 136 "indicator.vala"
		_tmp13_ = e;
#line 136 "indicator.vala"
		_tmp14_ = _tmp13_->message;
#line 136 "indicator.vala"
		_tmp15_ = g_strconcat ("Failed to create dbus node info: ", _tmp14_, NULL);
#line 136 "indicator.vala"
		_tmp16_ = _tmp15_;
#line 136 "indicator.vala"
		g_warning ("indicator.vala:136: %s", _tmp16_);
#line 136 "indicator.vala"
		_g_free0 (_tmp16_);
#line 137 "indicator.vala"
		_g_error_free0 (e);
#line 137 "indicator.vala"
		_g_free0 (path);
#line 137 "indicator.vala"
		return self;
#line 834 "indicator.c"
	}
	__finally0:
#line 132 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "indicator.vala"
		_g_free0 (path);
#line 132 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 132 "indicator.vala"
		return NULL;
#line 847 "indicator.c"
	}
#line 139 "indicator.vala"
	_tmp17_ = self->priv->m_watcher_node_info;
#line 139 "indicator.vala"
	_tmp18_ = g_dbus_node_info_lookup_interface (_tmp17_, INDICATOR_NOTIFICATION_WATCHER_DBUS_IFACE);
#line 139 "indicator.vala"
	self->priv->m_watcher_interface_info = _tmp18_;
#line 142 "indicator.vala"
	g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, INDICATOR_NOTIFICATION_WATCHER_DBUS_ADDR, G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_indicator_name_appeared_handler_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _indicator_name_appeared_handler_gbus_name_appeared_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((_indicator_name_vanished_handler_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _indicator_name_vanished_handler_gbus_name_vanished_callback, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 147 "indicator.vala"
	g_bus_get (G_BUS_TYPE_SESSION, NULL, ___lambda7__gasync_ready_callback, g_object_ref (self));
#line 108 "indicator.vala"
	_g_free0 (path);
#line 108 "indicator.vala"
	return self;
#line 863 "indicator.c"
}

Indicator*
indicator_new (const gchar* id,
               IndicatorCategory category)
{
#line 108 "indicator.vala"
	return indicator_construct (TYPE_INDICATOR, id, category);
#line 872 "indicator.c"
}

static void
__lambda4_ (Indicator* self,
            GObject* obj,
            GAsyncResult* res)
{
#line 171 "indicator.vala"
	g_return_if_fail (res != NULL);
#line 172 "indicator.vala"
	indicator_bus_watcher_ready (self, obj, res);
#line 884 "indicator.c"
}

static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 162 "indicator.vala"
	__lambda4_ ((Indicator*) self, source_object, res);
#line 162 "indicator.vala"
	g_object_unref (self);
#line 896 "indicator.c"
}

static void
indicator_name_appeared_handler (Indicator* self,
                                 GDBusConnection* connection,
                                 const gchar* name,
                                 const gchar* name_owner)
{
	GDBusInterfaceInfo* _tmp0_;
#line 158 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 158 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 158 "indicator.vala"
	g_return_if_fail (name != NULL);
#line 158 "indicator.vala"
	g_return_if_fail (name_owner != NULL);
#line 162 "indicator.vala"
	_tmp0_ = self->priv->m_watcher_interface_info;
#line 162 "indicator.vala"
	g_dbus_proxy_new (connection, G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES | G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS, _tmp0_, INDICATOR_NOTIFICATION_WATCHER_DBUS_ADDR, INDICATOR_NOTIFICATION_WATCHER_DBUS_OBJ, INDICATOR_NOTIFICATION_WATCHER_DBUS_IFACE, NULL, ___lambda4__gasync_ready_callback, g_object_ref (self));
#line 918 "indicator.c"
}

static void
indicator_name_vanished_handler (Indicator* self,
                                 GDBusConnection* connection,
                                 const gchar* name)
{
#line 177 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 177 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 177 "indicator.vala"
	g_return_if_fail (name != NULL);
#line 179 "indicator.vala"
	_g_object_unref0 (self->priv->m_proxy);
#line 179 "indicator.vala"
	self->priv->m_proxy = NULL;
#line 936 "indicator.c"
}

static void
indicator_check_connect (Indicator* self)
{
	GDBusConnection* _tmp0_;
	GDBusConnection* _tmp1_;
	GDBusConnection* _tmp2_;
	gboolean _tmp3_;
	GtkMenu* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 183 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 184 "indicator.vala"
	g_object_get ((IBusService*) self, "connection", &_tmp0_, NULL);
#line 184 "indicator.vala"
	_tmp1_ = _tmp0_;
#line 184 "indicator.vala"
	_tmp2_ = _tmp1_;
#line 184 "indicator.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 184 "indicator.vala"
	_g_object_unref0 (_tmp2_);
#line 184 "indicator.vala"
	if (_tmp3_) {
#line 185 "indicator.vala"
		return;
#line 964 "indicator.c"
	}
#line 186 "indicator.vala"
	_tmp4_ = self->priv->m_menu;
#line 186 "indicator.vala"
	if (_tmp4_ == NULL) {
#line 187 "indicator.vala"
		return;
#line 972 "indicator.c"
	}
	{
#line 189 "indicator.vala"
		if (!self->priv->m_registered) {
#line 977 "indicator.c"
			gboolean _tmp5_ = FALSE;
			GDBusConnection* _tmp6_;
			GDBusConnection* _tmp7_;
			GDBusConnection* _tmp8_;
			gboolean _tmp9_;
#line 190 "indicator.vala"
			g_object_get ((IBusService*) self, "connection", &_tmp6_, NULL);
#line 190 "indicator.vala"
			_tmp7_ = _tmp6_;
#line 190 "indicator.vala"
			_tmp8_ = _tmp7_;
#line 190 "indicator.vala"
			_tmp9_ = ibus_service_register ((IBusService*) self, _tmp8_, &_inner_error0_);
#line 190 "indicator.vala"
			_g_object_unref0 (_tmp8_);
#line 190 "indicator.vala"
			_tmp5_ = _tmp9_;
#line 190 "indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 997 "indicator.c"
				goto __catch0_g_error;
			}
#line 190 "indicator.vala"
			if (!_tmp5_) {
#line 191 "indicator.vala"
				return;
#line 1004 "indicator.c"
			} else {
#line 193 "indicator.vala"
				self->priv->m_registered = TRUE;
#line 1008 "indicator.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 188 "indicator.vala"
		e = _inner_error0_;
#line 188 "indicator.vala"
		_inner_error0_ = NULL;
#line 196 "indicator.vala"
		_tmp10_ = e;
#line 196 "indicator.vala"
		_tmp11_ = _tmp10_->message;
#line 196 "indicator.vala"
		_tmp12_ = g_strconcat ("Failed to register the application indicator xml: ", _tmp11_, NULL);
#line 196 "indicator.vala"
		_tmp13_ = _tmp12_;
#line 196 "indicator.vala"
		g_warning ("indicator.vala:196: %s", _tmp13_);
#line 196 "indicator.vala"
		_g_free0 (_tmp13_);
#line 198 "indicator.vala"
		_g_error_free0 (e);
#line 198 "indicator.vala"
		return;
#line 1040 "indicator.c"
	}
	__finally0:
#line 188 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 188 "indicator.vala"
		return;
#line 1051 "indicator.c"
	}
}

static void
___lambda5_ (Indicator* self,
             GObject* obj,
             GParamSpec* pspec)
{
	gchar* name = NULL;
	GDBusProxy* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 212 "indicator.vala"
	g_return_if_fail (obj != NULL);
#line 212 "indicator.vala"
	g_return_if_fail (pspec != NULL);
#line 213 "indicator.vala"
	_tmp0_ = self->priv->m_proxy;
#line 213 "indicator.vala"
	_tmp1_ = g_dbus_proxy_get_name_owner (_tmp0_);
#line 213 "indicator.vala"
	name = _tmp1_;
#line 214 "indicator.vala"
	_tmp2_ = name;
#line 214 "indicator.vala"
	if (_tmp2_ != NULL) {
#line 215 "indicator.vala"
		indicator_check_connect (self);
#line 1080 "indicator.c"
	}
#line 212 "indicator.vala"
	_g_free0 (name);
#line 1084 "indicator.c"
}

static void
____lambda5__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 212 "indicator.vala"
	___lambda5_ ((Indicator*) self, _sender, pspec);
#line 1094 "indicator.c"
}

static void
__lambda6_ (Indicator* self,
            GObject* p_obj,
            GAsyncResult* p_res)
{
	GError* _inner_error0_ = NULL;
#line 229 "indicator.vala"
	g_return_if_fail (p_res != NULL);
#line 1105 "indicator.c"
	{
		GDBusProxy* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
#line 231 "indicator.vala"
		_tmp0_ = self->priv->m_proxy;
#line 231 "indicator.vala"
		_tmp1_ = g_dbus_proxy_call_finish (_tmp0_, p_res, &_inner_error0_);
#line 231 "indicator.vala"
		_tmp2_ = _tmp1_;
#line 231 "indicator.vala"
		_g_variant_unref0 (_tmp2_);
#line 231 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1120 "indicator.c"
			goto __catch0_g_error;
		}
#line 232 "indicator.vala"
		g_signal_emit (self, indicator_signals[INDICATOR_REGISTERED_STATUS_NOTIFIER_ITEM_SIGNAL], 0);
#line 1125 "indicator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 230 "indicator.vala"
		e = _inner_error0_;
#line 230 "indicator.vala"
		_inner_error0_ = NULL;
#line 234 "indicator.vala"
		_tmp3_ = e;
#line 234 "indicator.vala"
		_tmp4_ = _tmp3_->message;
#line 234 "indicator.vala"
		_tmp5_ = g_strconcat ("Failed to call " "RegisterStatusNotifierItem: ", _tmp4_, NULL);
#line 234 "indicator.vala"
		_tmp6_ = _tmp5_;
#line 234 "indicator.vala"
		g_warning ("indicator.vala:234: %s", _tmp6_);
#line 234 "indicator.vala"
		_g_free0 (_tmp6_);
#line 230 "indicator.vala"
		_g_error_free0 (e);
#line 1153 "indicator.c"
	}
	__finally0:
#line 230 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 230 "indicator.vala"
		return;
#line 1164 "indicator.c"
	}
}

static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 224 "indicator.vala"
	__lambda6_ ((Indicator*) self, source_object, res);
#line 224 "indicator.vala"
	g_object_unref (self);
#line 1177 "indicator.c"
}

static void
indicator_bus_watcher_ready (Indicator* self,
                             GObject* obj,
                             GAsyncResult* res)
{
	gchar* name = NULL;
	GDBusProxy* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	GDBusProxy* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 203 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 204 "indicator.vala"
	if (res != NULL) {
#line 1199 "indicator.c"
		GDBusProxy* _tmp7_;
		{
			GDBusProxy* _tmp0_ = NULL;
			GDBusProxy* _tmp1_;
			GDBusProxy* _tmp2_;
#line 206 "indicator.vala"
			_tmp1_ = g_dbus_proxy_new_finish (res, &_inner_error0_);
#line 206 "indicator.vala"
			_tmp0_ = _tmp1_;
#line 206 "indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "indicator.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 1213 "indicator.c"
					goto __catch0_g_io_error;
				}
#line 206 "indicator.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "indicator.vala"
				g_clear_error (&_inner_error0_);
#line 206 "indicator.vala"
				return;
#line 1222 "indicator.c"
			}
#line 206 "indicator.vala"
			_tmp2_ = _tmp0_;
#line 206 "indicator.vala"
			_tmp0_ = NULL;
#line 206 "indicator.vala"
			_g_object_unref0 (self->priv->m_proxy);
#line 206 "indicator.vala"
			self->priv->m_proxy = _tmp2_;
#line 205 "indicator.vala"
			_g_object_unref0 (_tmp0_);
#line 1234 "indicator.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 205 "indicator.vala"
			e = _inner_error0_;
#line 205 "indicator.vala"
			_inner_error0_ = NULL;
#line 208 "indicator.vala"
			_tmp3_ = e;
#line 208 "indicator.vala"
			_tmp4_ = _tmp3_->message;
#line 208 "indicator.vala"
			_tmp5_ = g_strconcat ("Failed to call dbus proxy: ", _tmp4_, NULL);
#line 208 "indicator.vala"
			_tmp6_ = _tmp5_;
#line 208 "indicator.vala"
			g_warning ("indicator.vala:208: %s", _tmp6_);
#line 208 "indicator.vala"
			_g_free0 (_tmp6_);
#line 209 "indicator.vala"
			_g_error_free0 (e);
#line 209 "indicator.vala"
			return;
#line 1264 "indicator.c"
		}
		__finally0:
#line 205 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 205 "indicator.vala"
			g_clear_error (&_inner_error0_);
#line 205 "indicator.vala"
			return;
#line 1275 "indicator.c"
		}
#line 212 "indicator.vala"
		_tmp7_ = self->priv->m_proxy;
#line 212 "indicator.vala"
		g_signal_connect_object ((GObject*) _tmp7_, "notify::g-name-owner", (GCallback) ____lambda5__g_object_notify, self, 0);
#line 1281 "indicator.c"
	}
#line 219 "indicator.vala"
	_tmp8_ = self->priv->m_proxy;
#line 219 "indicator.vala"
	_tmp9_ = g_dbus_proxy_get_name_owner (_tmp8_);
#line 219 "indicator.vala"
	name = _tmp9_;
#line 221 "indicator.vala"
	_tmp10_ = name;
#line 221 "indicator.vala"
	if (_tmp10_ == NULL) {
#line 222 "indicator.vala"
		_g_free0 (name);
#line 222 "indicator.vala"
		return;
#line 1297 "indicator.c"
	}
#line 224 "indicator.vala"
	_tmp11_ = self->priv->m_proxy;
#line 224 "indicator.vala"
	_tmp12_ = ibus_service_get_object_path ((IBusService*) self);
#line 224 "indicator.vala"
	_tmp13_ = _tmp12_;
#line 224 "indicator.vala"
	_tmp14_ = g_variant_new ("(s)", _tmp13_, NULL);
#line 224 "indicator.vala"
	g_variant_ref_sink (_tmp14_);
#line 224 "indicator.vala"
	_tmp15_ = _tmp14_;
#line 224 "indicator.vala"
	g_dbus_proxy_call (_tmp11_, "RegisterStatusNotifierItem", _tmp15_, G_DBUS_CALL_FLAGS_NONE, -1, NULL, ___lambda6__gasync_ready_callback, g_object_ref (self));
#line 224 "indicator.vala"
	_g_variant_unref0 (_tmp15_);
#line 203 "indicator.vala"
	_g_free0 (name);
#line 1317 "indicator.c"
}

static void
_indicator_context_menu_cb (Indicator* self,
                            GDBusConnection* connection,
                            GVariant* parameters,
                            GDBusMethodInvocation* invocation)
{
	GVariant* var_x = NULL;
	GVariant* _tmp0_;
	GVariant* var_y = NULL;
	GVariant* _tmp1_;
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
#line 242 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 242 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 242 "indicator.vala"
	g_return_if_fail (parameters != NULL);
#line 242 "indicator.vala"
	g_return_if_fail (invocation != NULL);
#line 245 "indicator.vala"
	_tmp0_ = g_variant_get_child_value (parameters, (gsize) 0);
#line 245 "indicator.vala"
	var_x = _tmp0_;
#line 246 "indicator.vala"
	_tmp1_ = g_variant_get_child_value (parameters, (gsize) 1);
#line 246 "indicator.vala"
	var_y = _tmp1_;
#line 247 "indicator.vala"
	self->priv->m_context_menu_x = (gint) g_variant_get_int32 (var_x);
#line 248 "indicator.vala"
	self->priv->m_context_menu_y = (gint) g_variant_get_int32 (var_y);
#line 249 "indicator.vala"
	_tmp2_ = indicator_query_gdk_window (self);
#line 249 "indicator.vala"
	window = _tmp2_;
#line 250 "indicator.vala"
	g_signal_emit (self, indicator_signals[INDICATOR_CONTEXT_MENU_SIGNAL], 0, self->priv->m_context_menu_x, self->priv->m_context_menu_y, window, (guint) 2, (guint) 0);
#line 242 "indicator.vala"
	_g_object_unref0 (window);
#line 242 "indicator.vala"
	_g_variant_unref0 (var_y);
#line 242 "indicator.vala"
	_g_variant_unref0 (var_x);
#line 1364 "indicator.c"
}

static void
_indicator_activate_menu_cb (Indicator* self,
                             GDBusConnection* connection,
                             GVariant* parameters,
                             GDBusMethodInvocation* invocation)
{
	GVariant* var_x = NULL;
	GVariant* _tmp0_;
	GVariant* var_y = NULL;
	GVariant* _tmp1_;
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
#line 254 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 254 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 254 "indicator.vala"
	g_return_if_fail (parameters != NULL);
#line 254 "indicator.vala"
	g_return_if_fail (invocation != NULL);
#line 257 "indicator.vala"
	_tmp0_ = g_variant_get_child_value (parameters, (gsize) 0);
#line 257 "indicator.vala"
	var_x = _tmp0_;
#line 258 "indicator.vala"
	_tmp1_ = g_variant_get_child_value (parameters, (gsize) 1);
#line 258 "indicator.vala"
	var_y = _tmp1_;
#line 259 "indicator.vala"
	self->priv->m_activate_menu_x = (gint) g_variant_get_int32 (var_x);
#line 260 "indicator.vala"
	self->priv->m_activate_menu_y = (gint) g_variant_get_int32 (var_y);
#line 261 "indicator.vala"
	_tmp2_ = indicator_query_gdk_window (self);
#line 261 "indicator.vala"
	window = _tmp2_;
#line 262 "indicator.vala"
	g_signal_emit (self, indicator_signals[INDICATOR_ACTIVATE_SIGNAL], 0, self->priv->m_activate_menu_x, self->priv->m_activate_menu_y, window);
#line 254 "indicator.vala"
	_g_object_unref0 (window);
#line 254 "indicator.vala"
	_g_variant_unref0 (var_y);
#line 254 "indicator.vala"
	_g_variant_unref0 (var_x);
#line 1411 "indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 268 "indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 1419 "indicator.c"
}

static GdkWindow*
indicator_query_gdk_window (Indicator* self)
{
	GdkWindow* _tmp0_;
	GdkX11Display* display = NULL;
	GdkX11Display* _tmp3_;
	GdkX11Display* _tmp4_;
	Display* xdisplay = NULL;
	GdkX11Display* _tmp5_;
	Display* _tmp6_;
	Window current = 0;
	Display* _tmp7_;
	Window parent = 0;
	Window child = 0;
	gint root_x = 0;
	gint root_y = 0;
	gint win_x = 0;
	gint win_y = 0;
	guint mask = 0U;
	gboolean retval = FALSE;
	Display* _tmp22_;
	GdkX11Display* _tmp23_;
	GdkX11Window* _tmp24_;
	GdkWindow* _tmp25_;
	GdkWindow* _tmp26_;
	GdkX11Display* _tmp29_;
	GdkX11Window* _tmp30_;
	GdkWindow* _tmp31_;
	GdkWindow* _tmp32_;
	GdkWindow* result;
#line 266 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "indicator.vala"
	_tmp0_ = self->priv->m_indicator_window;
#line 267 "indicator.vala"
	if (_tmp0_ != NULL) {
#line 1458 "indicator.c"
		GdkWindow* _tmp1_;
		GdkWindow* _tmp2_;
#line 268 "indicator.vala"
		_tmp1_ = self->priv->m_indicator_window;
#line 268 "indicator.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 268 "indicator.vala"
		result = _tmp2_;
#line 268 "indicator.vala"
		return result;
#line 1469 "indicator.c"
	}
#line 270 "indicator.vala"
	_tmp3_ = binding_common_get_xdisplay ();
#line 270 "indicator.vala"
	display = _tmp3_;
#line 271 "indicator.vala"
	_tmp4_ = display;
#line 271 "indicator.vala"
	if (_tmp4_ == NULL) {
#line 272 "indicator.vala"
		result = NULL;
#line 272 "indicator.vala"
		_g_object_unref0 (display);
#line 272 "indicator.vala"
		return result;
#line 1485 "indicator.c"
	}
#line 273 "indicator.vala"
	_tmp5_ = display;
#line 273 "indicator.vala"
	_tmp6_ = gdk_x11_display_get_xdisplay (_tmp5_);
#line 273 "indicator.vala"
	xdisplay = _tmp6_;
#line 274 "indicator.vala"
	_tmp7_ = xdisplay;
#line 274 "indicator.vala"
	current = DefaultRootWindow (_tmp7_);
#line 275 "indicator.vala"
	parent = (Window) 0;
#line 276 "indicator.vala"
	child = (Window) 0;
#line 278 "indicator.vala"
	mask = (guint) 0;
#line 279 "indicator.vala"
	win_y = 0;
#line 279 "indicator.vala"
	win_x = win_y;
#line 279 "indicator.vala"
	root_y = win_x;
#line 279 "indicator.vala"
	root_x = root_y;
#line 282 "indicator.vala"
	while (TRUE) {
#line 1513 "indicator.c"
		Display* _tmp8_;
		Window _tmp9_ = 0;
		Window _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		guint _tmp15_ = 0U;
		gboolean _tmp16_;
#line 282 "indicator.vala"
		_tmp8_ = xdisplay;
#line 282 "indicator.vala"
		_tmp16_ = XQueryPointer (_tmp8_, current, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 282 "indicator.vala"
		parent = _tmp9_;
#line 282 "indicator.vala"
		child = _tmp10_;
#line 282 "indicator.vala"
		root_x = _tmp11_;
#line 282 "indicator.vala"
		root_y = _tmp12_;
#line 282 "indicator.vala"
		win_x = _tmp13_;
#line 282 "indicator.vala"
		win_y = _tmp14_;
#line 282 "indicator.vala"
		mask = _tmp15_;
#line 282 "indicator.vala"
		retval = _tmp16_;
#line 282 "indicator.vala"
		if (!retval) {
#line 282 "indicator.vala"
			break;
#line 1547 "indicator.c"
		}
#line 287 "indicator.vala"
		if (child == ((Window) 0)) {
#line 288 "indicator.vala"
			break;
#line 1553 "indicator.c"
		}
#line 289 "indicator.vala"
		current = child;
#line 1557 "indicator.c"
	}
#line 291 "indicator.vala"
	if (!retval) {
#line 1561 "indicator.c"
		gchar* format = NULL;
		gchar* _tmp17_;
		gchar* message = NULL;
		const gchar* _tmp18_;
		Display* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
#line 292 "indicator.vala"
		_tmp17_ = g_strdup ("XQueryPointer is failed: current: %x root: %x " "child: %x (%d, %d), (%d, %d), %u");
#line 292 "indicator.vala"
		format = _tmp17_;
#line 295 "indicator.vala"
		_tmp18_ = format;
#line 295 "indicator.vala"
		_tmp19_ = xdisplay;
#line 295 "indicator.vala"
		_tmp20_ = g_strdup_printf (_tmp18_, (guint) current, (guint) DefaultRootWindow (_tmp19_), (guint) child, root_x, root_y, win_x, win_y, mask);
#line 295 "indicator.vala"
		message = _tmp20_;
#line 300 "indicator.vala"
		_tmp21_ = message;
#line 300 "indicator.vala"
		g_warning ("indicator.vala:300: XQueryPointer is failed: %s", _tmp21_);
#line 301 "indicator.vala"
		result = NULL;
#line 301 "indicator.vala"
		_g_free0 (message);
#line 301 "indicator.vala"
		_g_free0 (format);
#line 301 "indicator.vala"
		_g_object_unref0 (display);
#line 301 "indicator.vala"
		return result;
#line 1595 "indicator.c"
	}
#line 303 "indicator.vala"
	_tmp22_ = xdisplay;
#line 303 "indicator.vala"
	if (current == DefaultRootWindow (_tmp22_)) {
#line 304 "indicator.vala"
		g_warning ("indicator.vala:304: The query window is root window");
#line 1603 "indicator.c"
	}
#line 305 "indicator.vala"
	_tmp23_ = display;
#line 305 "indicator.vala"
	_tmp24_ = gdk_x11_window_lookup_for_display (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp23_) : NULL, current);
#line 305 "indicator.vala"
	_tmp25_ = _g_object_ref0 ((GdkWindow*) _tmp24_);
#line 305 "indicator.vala"
	_g_object_unref0 (self->priv->m_indicator_window);
#line 305 "indicator.vala"
	self->priv->m_indicator_window = _tmp25_;
#line 308 "indicator.vala"
	_tmp26_ = self->priv->m_indicator_window;
#line 308 "indicator.vala"
	if (_tmp26_ != NULL) {
#line 1619 "indicator.c"
		GdkWindow* _tmp27_;
		GdkWindow* _tmp28_;
#line 309 "indicator.vala"
		_tmp27_ = self->priv->m_indicator_window;
#line 309 "indicator.vala"
		_tmp28_ = _g_object_ref0 (_tmp27_);
#line 309 "indicator.vala"
		result = _tmp28_;
#line 309 "indicator.vala"
		_g_object_unref0 (display);
#line 309 "indicator.vala"
		return result;
#line 1632 "indicator.c"
	}
#line 310 "indicator.vala"
	_tmp29_ = display;
#line 310 "indicator.vala"
	_tmp30_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp29_) : NULL, current);
#line 310 "indicator.vala"
	_g_object_unref0 (self->priv->m_indicator_window);
#line 310 "indicator.vala"
	self->priv->m_indicator_window = (GdkWindow*) _tmp30_;
#line 313 "indicator.vala"
	_tmp31_ = self->priv->m_indicator_window;
#line 313 "indicator.vala"
	_tmp32_ = _g_object_ref0 (_tmp31_);
#line 313 "indicator.vala"
	result = _tmp32_;
#line 313 "indicator.vala"
	_g_object_unref0 (display);
#line 313 "indicator.vala"
	return result;
#line 1652 "indicator.c"
}

static GVariant*
_indicator_get_id (Indicator* self,
                   GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 317 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 317 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 318 "indicator.vala"
	_tmp0_ = self->priv->_id;
#line 318 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 318 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 318 "indicator.vala"
	result = _tmp1_;
#line 318 "indicator.vala"
	return result;
#line 1676 "indicator.c"
}

static GVariant*
_indicator_get_category (Indicator* self,
                         GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 322 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 322 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 323 "indicator.vala"
	_tmp0_ = self->priv->_category_s;
#line 323 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 323 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 323 "indicator.vala"
	result = _tmp1_;
#line 323 "indicator.vala"
	return result;
#line 1700 "indicator.c"
}

static GVariant*
_indicator_get_status (Indicator* self,
                       GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 327 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 328 "indicator.vala"
	_tmp0_ = self->priv->_status_s;
#line 328 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 328 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 328 "indicator.vala"
	result = _tmp1_;
#line 328 "indicator.vala"
	return result;
#line 1724 "indicator.c"
}

static GVariant*
_indicator_get_icon_name (Indicator* self,
                          GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 332 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 333 "indicator.vala"
	_tmp0_ = self->priv->_icon_name;
#line 333 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 333 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 333 "indicator.vala"
	result = _tmp1_;
#line 333 "indicator.vala"
	return result;
#line 1748 "indicator.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 338 "indicator.vala"
	return self ? g_variant_ref (self) : NULL;
#line 1756 "indicator.c"
}

static GVariant*
_indicator_get_icon_vector (Indicator* self,
                            GDBusConnection* connection)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 337 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 338 "indicator.vala"
	_tmp0_ = self->priv->_icon_vector;
#line 338 "indicator.vala"
	_tmp1_ = _g_variant_ref0 (_tmp0_);
#line 338 "indicator.vala"
	result = _tmp1_;
#line 338 "indicator.vala"
	return result;
#line 1778 "indicator.c"
}

static GVariant*
_indicator_get_icon_desc (Indicator* self,
                          GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 342 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 343 "indicator.vala"
	_tmp0_ = self->priv->_icon_desc;
#line 343 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 343 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 343 "indicator.vala"
	result = _tmp1_;
#line 343 "indicator.vala"
	return result;
#line 1802 "indicator.c"
}

static GVariant*
_indicator_get_attention_icon_name (Indicator* self,
                                    GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 347 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 347 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 349 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_name;
#line 349 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 349 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 349 "indicator.vala"
	result = _tmp1_;
#line 349 "indicator.vala"
	return result;
#line 1826 "indicator.c"
}

static GVariant*
_indicator_get_attention_icon_desc (Indicator* self,
                                    GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 353 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 353 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 355 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_desc;
#line 355 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 355 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 355 "indicator.vala"
	result = _tmp1_;
#line 355 "indicator.vala"
	return result;
#line 1850 "indicator.c"
}

static GVariant*
_indicator_get_title (Indicator* self,
                      GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 359 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 360 "indicator.vala"
	_tmp0_ = self->priv->_title;
#line 360 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 360 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 360 "indicator.vala"
	result = _tmp1_;
#line 360 "indicator.vala"
	return result;
#line 1874 "indicator.c"
}

static GVariant*
_indicator_get_icon_theme_path (Indicator* self,
                                GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 364 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 364 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 365 "indicator.vala"
	_tmp0_ = self->priv->_icon_theme_path;
#line 365 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 365 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 365 "indicator.vala"
	result = _tmp1_;
#line 365 "indicator.vala"
	return result;
#line 1898 "indicator.c"
}

static GVariant*
_indicator_get_menu (Indicator* self,
                     GDBusConnection* connection)
{
	DbusmenuServer* _tmp0_;
	GVariant* _tmp5_;
	GVariant* result;
#line 369 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 369 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 370 "indicator.vala"
	_tmp0_ = self->priv->m_dbusmenu_server;
#line 370 "indicator.vala"
	if (_tmp0_ != NULL) {
#line 1916 "indicator.c"
		gchar* o = NULL;
		DbusmenuServer* _tmp1_;
		gchar* _tmp2_ = NULL;
		GVariant* variant = NULL;
		const gchar* _tmp3_;
		GVariant* _tmp4_;
#line 372 "indicator.vala"
		_tmp1_ = self->priv->m_dbusmenu_server;
#line 372 "indicator.vala"
		g_object_get ((GObject*) _tmp1_, DBUSMENU_SERVER_PROP_DBUS_OBJECT, &_tmp2_, NULL);
#line 372 "indicator.vala"
		_g_free0 (o);
#line 372 "indicator.vala"
		o = _tmp2_;
#line 373 "indicator.vala"
		_tmp3_ = o;
#line 373 "indicator.vala"
		_tmp4_ = g_variant_new ("o", _tmp3_, NULL);
#line 373 "indicator.vala"
		g_variant_ref_sink (_tmp4_);
#line 373 "indicator.vala"
		variant = _tmp4_;
#line 374 "indicator.vala"
		result = variant;
#line 374 "indicator.vala"
		_g_free0 (o);
#line 374 "indicator.vala"
		return result;
#line 1945 "indicator.c"
	}
#line 376 "indicator.vala"
	_tmp5_ = g_variant_new ("o", "/", NULL);
#line 376 "indicator.vala"
	g_variant_ref_sink (_tmp5_);
#line 376 "indicator.vala"
	result = _tmp5_;
#line 376 "indicator.vala"
	return result;
#line 1955 "indicator.c"
}

static GVariant*
_indicator_get_xayatana_label (Indicator* self,
                               GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 380 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 380 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 381 "indicator.vala"
	_tmp0_ = self->priv->_label_s;
#line 381 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 381 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 381 "indicator.vala"
	result = _tmp1_;
#line 381 "indicator.vala"
	return result;
#line 1979 "indicator.c"
}

static GVariant*
_indicator_get_xayatana_label_guide (Indicator* self,
                                     GDBusConnection* connection)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 385 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 385 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 387 "indicator.vala"
	_tmp0_ = self->priv->_label_guide_s;
#line 387 "indicator.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 387 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 387 "indicator.vala"
	result = _tmp1_;
#line 387 "indicator.vala"
	return result;
#line 2003 "indicator.c"
}

static GVariant*
_indicator_get_xayatana_ordering_index (Indicator* self,
                                        GDBusConnection* connection)
{
	guint32 _tmp0_;
	GVariant* _tmp1_;
	GVariant* result;
#line 391 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 391 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 393 "indicator.vala"
	_tmp0_ = self->priv->_ordering_index;
#line 393 "indicator.vala"
	_tmp1_ = g_variant_new_uint32 (_tmp0_);
#line 393 "indicator.vala"
	g_variant_ref_sink (_tmp1_);
#line 393 "indicator.vala"
	result = _tmp1_;
#line 393 "indicator.vala"
	return result;
#line 2027 "indicator.c"
}

static void
indicator_real_service_method_call (IBusService* base,
                                    GDBusConnection* connection,
                                    const gchar* sender,
                                    const gchar* object_path,
                                    const gchar* interface_name,
                                    const gchar* method_name,
                                    GVariant* parameters,
                                    GDBusMethodInvocation* invocation)
{
	Indicator * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 397 "indicator.vala"
	self = (Indicator*) base;
#line 397 "indicator.vala"
	g_return_if_fail (connection != NULL);
#line 397 "indicator.vala"
	g_return_if_fail (sender != NULL);
#line 397 "indicator.vala"
	g_return_if_fail (object_path != NULL);
#line 397 "indicator.vala"
	g_return_if_fail (interface_name != NULL);
#line 397 "indicator.vala"
	g_return_if_fail (method_name != NULL);
#line 397 "indicator.vala"
	g_return_if_fail (parameters != NULL);
#line 397 "indicator.vala"
	g_return_if_fail (invocation != NULL);
#line 406 "indicator.vala"
	_tmp0_ = ibus_service_get_object_path ((IBusService*) self);
#line 406 "indicator.vala"
	_tmp1_ = _tmp0_;
#line 406 "indicator.vala"
	g_return_if_fail (g_strcmp0 (object_path, _tmp1_) == 0);
#line 407 "indicator.vala"
	g_return_if_fail (g_strcmp0 (interface_name, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE) == 0);
#line 409 "indicator.vala"
	if (g_strcmp0 (method_name, "Activate") == 0) {
#line 410 "indicator.vala"
		_indicator_activate_menu_cb (self, connection, parameters, invocation);
#line 411 "indicator.vala"
		return;
#line 2075 "indicator.c"
	}
#line 413 "indicator.vala"
	if (g_strcmp0 (method_name, "ContextMenu") == 0) {
#line 414 "indicator.vala"
		_indicator_context_menu_cb (self, connection, parameters, invocation);
#line 415 "indicator.vala"
		return;
#line 2083 "indicator.c"
	}
#line 417 "indicator.vala"
	if (g_strcmp0 (method_name, "SecondaryActivate") == 0) {
#line 418 "indicator.vala"
		g_signal_emit (self, indicator_signals[INDICATOR_SECONDARY_ACTIVATE_SIGNAL], 0);
#line 419 "indicator.vala"
		return;
#line 2091 "indicator.c"
	}
#line 422 "indicator.vala"
	_tmp2_ = g_strconcat ("service_method_call() does not handle the method: ", method_name, NULL);
#line 422 "indicator.vala"
	_tmp3_ = _tmp2_;
#line 422 "indicator.vala"
	g_warning ("indicator.vala:422: %s", _tmp3_);
#line 422 "indicator.vala"
	_g_free0 (_tmp3_);
#line 2101 "indicator.c"
}

static GVariant*
indicator_real_service_get_property (IBusService* base,
                                     GDBusConnection* connection,
                                     const gchar* sender,
                                     const gchar* object_path,
                                     const gchar* interface_name,
                                     const gchar* property_name,
                                     GError** error)
{
	Indicator * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GVariant* result;
#line 427 "indicator.vala"
	self = (Indicator*) base;
#line 427 "indicator.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 427 "indicator.vala"
	g_return_val_if_fail (sender != NULL, NULL);
#line 427 "indicator.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 427 "indicator.vala"
	g_return_val_if_fail (interface_name != NULL, NULL);
#line 427 "indicator.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 433 "indicator.vala"
	_tmp0_ = ibus_service_get_object_path ((IBusService*) self);
#line 433 "indicator.vala"
	_tmp1_ = _tmp0_;
#line 433 "indicator.vala"
	g_return_val_if_fail (g_strcmp0 (object_path, _tmp1_) == 0, NULL);
#line 434 "indicator.vala"
	g_return_val_if_fail (g_strcmp0 (interface_name, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE) == 0, NULL);
#line 438 "indicator.vala"
	if (g_strcmp0 (property_name, "Id") == 0) {
#line 2141 "indicator.c"
		GVariant* _tmp2_;
#line 439 "indicator.vala"
		_tmp2_ = _indicator_get_id (self, connection);
#line 439 "indicator.vala"
		result = _tmp2_;
#line 439 "indicator.vala"
		return result;
#line 2149 "indicator.c"
	}
#line 440 "indicator.vala"
	if (g_strcmp0 (property_name, "Category") == 0) {
#line 2153 "indicator.c"
		GVariant* _tmp3_;
#line 441 "indicator.vala"
		_tmp3_ = _indicator_get_category (self, connection);
#line 441 "indicator.vala"
		result = _tmp3_;
#line 441 "indicator.vala"
		return result;
#line 2161 "indicator.c"
	}
#line 442 "indicator.vala"
	if (g_strcmp0 (property_name, "Status") == 0) {
#line 2165 "indicator.c"
		GVariant* _tmp4_;
#line 443 "indicator.vala"
		_tmp4_ = _indicator_get_status (self, connection);
#line 443 "indicator.vala"
		result = _tmp4_;
#line 443 "indicator.vala"
		return result;
#line 2173 "indicator.c"
	}
#line 444 "indicator.vala"
	if (g_strcmp0 (property_name, "IconName") == 0) {
#line 2177 "indicator.c"
		GVariant* _tmp5_;
#line 445 "indicator.vala"
		_tmp5_ = _indicator_get_icon_name (self, connection);
#line 445 "indicator.vala"
		result = _tmp5_;
#line 445 "indicator.vala"
		return result;
#line 2185 "indicator.c"
	}
#line 446 "indicator.vala"
	if (g_strcmp0 (property_name, "IconPixmap") == 0) {
#line 2189 "indicator.c"
		GVariant* _tmp6_;
#line 447 "indicator.vala"
		_tmp6_ = _indicator_get_icon_vector (self, connection);
#line 447 "indicator.vala"
		result = _tmp6_;
#line 447 "indicator.vala"
		return result;
#line 2197 "indicator.c"
	}
#line 448 "indicator.vala"
	if (g_strcmp0 (property_name, "IconAccessibleDesc") == 0) {
#line 2201 "indicator.c"
		GVariant* _tmp7_;
#line 449 "indicator.vala"
		_tmp7_ = _indicator_get_icon_desc (self, connection);
#line 449 "indicator.vala"
		result = _tmp7_;
#line 449 "indicator.vala"
		return result;
#line 2209 "indicator.c"
	}
#line 450 "indicator.vala"
	if (g_strcmp0 (property_name, "AttentionIconName") == 0) {
#line 2213 "indicator.c"
		GVariant* _tmp8_;
#line 451 "indicator.vala"
		_tmp8_ = _indicator_get_attention_icon_name (self, connection);
#line 451 "indicator.vala"
		result = _tmp8_;
#line 451 "indicator.vala"
		return result;
#line 2221 "indicator.c"
	}
#line 452 "indicator.vala"
	if (g_strcmp0 (property_name, "AttentionAccessibleDesc") == 0) {
#line 2225 "indicator.c"
		GVariant* _tmp9_;
#line 453 "indicator.vala"
		_tmp9_ = _indicator_get_attention_icon_desc (self, connection);
#line 453 "indicator.vala"
		result = _tmp9_;
#line 453 "indicator.vala"
		return result;
#line 2233 "indicator.c"
	}
#line 454 "indicator.vala"
	if (g_strcmp0 (property_name, "Title") == 0) {
#line 2237 "indicator.c"
		GVariant* _tmp10_;
#line 455 "indicator.vala"
		_tmp10_ = _indicator_get_title (self, connection);
#line 455 "indicator.vala"
		result = _tmp10_;
#line 455 "indicator.vala"
		return result;
#line 2245 "indicator.c"
	}
#line 456 "indicator.vala"
	if (g_strcmp0 (property_name, "IconThemePath") == 0) {
#line 2249 "indicator.c"
		GVariant* _tmp11_;
#line 457 "indicator.vala"
		_tmp11_ = _indicator_get_icon_theme_path (self, connection);
#line 457 "indicator.vala"
		result = _tmp11_;
#line 457 "indicator.vala"
		return result;
#line 2257 "indicator.c"
	}
#line 458 "indicator.vala"
	if (g_strcmp0 (property_name, "Menu") == 0) {
#line 2261 "indicator.c"
		GVariant* _tmp12_;
#line 459 "indicator.vala"
		_tmp12_ = _indicator_get_menu (self, connection);
#line 459 "indicator.vala"
		result = _tmp12_;
#line 459 "indicator.vala"
		return result;
#line 2269 "indicator.c"
	}
#line 460 "indicator.vala"
	if (g_strcmp0 (property_name, "XAyatanaLabel") == 0) {
#line 2273 "indicator.c"
		GVariant* _tmp13_;
#line 461 "indicator.vala"
		_tmp13_ = _indicator_get_xayatana_label (self, connection);
#line 461 "indicator.vala"
		result = _tmp13_;
#line 461 "indicator.vala"
		return result;
#line 2281 "indicator.c"
	}
#line 462 "indicator.vala"
	if (g_strcmp0 (property_name, "XAyatanaLabelGuide") == 0) {
#line 2285 "indicator.c"
		GVariant* _tmp14_;
#line 463 "indicator.vala"
		_tmp14_ = _indicator_get_xayatana_label_guide (self, connection);
#line 463 "indicator.vala"
		result = _tmp14_;
#line 463 "indicator.vala"
		return result;
#line 2293 "indicator.c"
	}
#line 464 "indicator.vala"
	if (g_strcmp0 (property_name, "XAyatanaOrderingIndex") == 0) {
#line 2297 "indicator.c"
		GVariant* _tmp15_;
#line 465 "indicator.vala"
		_tmp15_ = _indicator_get_xayatana_ordering_index (self, connection);
#line 465 "indicator.vala"
		result = _tmp15_;
#line 465 "indicator.vala"
		return result;
#line 2305 "indicator.c"
	}
#line 467 "indicator.vala"
	_tmp16_ = g_strconcat ("service_get_property() does not handle the property: ", property_name, NULL);
#line 467 "indicator.vala"
	_tmp17_ = _tmp16_;
#line 467 "indicator.vala"
	g_warning ("indicator.vala:467: %s", _tmp17_);
#line 467 "indicator.vala"
	_g_free0 (_tmp17_);
#line 470 "indicator.vala"
	result = NULL;
#line 470 "indicator.vala"
	return result;
#line 2319 "indicator.c"
}

static gboolean
indicator_real_service_set_property (IBusService* base,
                                     GDBusConnection* connection,
                                     const gchar* sender,
                                     const gchar* object_path,
                                     const gchar* interface_name,
                                     const gchar* property_name,
                                     GVariant* value,
                                     GError** error)
{
	Indicator * self;
	gboolean result;
#line 474 "indicator.vala"
	self = (Indicator*) base;
#line 474 "indicator.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 474 "indicator.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 474 "indicator.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 474 "indicator.vala"
	g_return_val_if_fail (interface_name != NULL, FALSE);
#line 474 "indicator.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 474 "indicator.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 481 "indicator.vala"
	result = FALSE;
#line 481 "indicator.vala"
	return result;
#line 2352 "indicator.c"
}

void
indicator_set_status (Indicator* self,
                      IndicatorStatus status)
{
	gchar* status_s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GDBusConnection* _tmp4_;
	GDBusConnection* _tmp5_;
	GDBusConnection* _tmp6_;
	gboolean _tmp7_;
	GError* _inner_error0_ = NULL;
#line 486 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 487 "indicator.vala"
	_tmp0_ = indicator_status_to_nick (status);
#line 487 "indicator.vala"
	status_s = _tmp0_;
#line 488 "indicator.vala"
	_tmp1_ = self->priv->_status_s;
#line 488 "indicator.vala"
	_tmp2_ = status_s;
#line 488 "indicator.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) == 0) {
#line 489 "indicator.vala"
		_g_free0 (status_s);
#line 489 "indicator.vala"
		return;
#line 2385 "indicator.c"
	}
#line 490 "indicator.vala"
	_tmp3_ = status_s;
#line 490 "indicator.vala"
	indicator_set_status_s (self, _tmp3_);
#line 497 "indicator.vala"
	g_object_get ((IBusService*) self, "connection", &_tmp4_, NULL);
#line 497 "indicator.vala"
	_tmp5_ = _tmp4_;
#line 497 "indicator.vala"
	_tmp6_ = _tmp5_;
#line 497 "indicator.vala"
	_tmp7_ = _tmp6_ == NULL;
#line 497 "indicator.vala"
	_g_object_unref0 (_tmp6_);
#line 497 "indicator.vala"
	if (_tmp7_) {
#line 498 "indicator.vala"
		_g_free0 (status_s);
#line 498 "indicator.vala"
		return;
#line 2407 "indicator.c"
	}
	{
		GDBusConnection* _tmp8_;
		GDBusConnection* _tmp9_;
		GDBusConnection* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GVariant* _tmp14_;
		GVariant* _tmp15_;
#line 500 "indicator.vala"
		g_object_get ((IBusService*) self, "connection", &_tmp8_, NULL);
#line 500 "indicator.vala"
		_tmp9_ = _tmp8_;
#line 500 "indicator.vala"
		_tmp10_ = _tmp9_;
#line 500 "indicator.vala"
		_tmp11_ = ibus_service_get_object_path ((IBusService*) self);
#line 500 "indicator.vala"
		_tmp12_ = _tmp11_;
#line 500 "indicator.vala"
		_tmp13_ = status_s;
#line 500 "indicator.vala"
		_tmp14_ = g_variant_new ("(s)", _tmp13_, NULL);
#line 500 "indicator.vala"
		g_variant_ref_sink (_tmp14_);
#line 500 "indicator.vala"
		_tmp15_ = _tmp14_;
#line 500 "indicator.vala"
		g_dbus_connection_emit_signal (_tmp10_, NULL, _tmp12_, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE, "NewStatus", _tmp15_, &_inner_error0_);
#line 500 "indicator.vala"
		_g_variant_unref0 (_tmp15_);
#line 500 "indicator.vala"
		_g_object_unref0 (_tmp10_);
#line 500 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2444 "indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 499 "indicator.vala"
		e = _inner_error0_;
#line 499 "indicator.vala"
		_inner_error0_ = NULL;
#line 506 "indicator.vala"
		_tmp16_ = e;
#line 506 "indicator.vala"
		_tmp17_ = _tmp16_->message;
#line 506 "indicator.vala"
		g_warning ("indicator.vala:506: Unable to send signal for NewIcon: %s", _tmp17_);
#line 499 "indicator.vala"
		_g_error_free0 (e);
#line 2466 "indicator.c"
	}
	__finally0:
#line 499 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 499 "indicator.vala"
		_g_free0 (status_s);
#line 499 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 499 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 499 "indicator.vala"
		return;
#line 2479 "indicator.c"
	}
#line 486 "indicator.vala"
	_g_free0 (status_s);
#line 2483 "indicator.c"
}

void
indicator_set_icon_full (Indicator* self,
                         const gchar* icon_name,
                         const gchar* icon_desc)
{
	gboolean changed = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GDBusConnection* _tmp3_;
	GDBusConnection* _tmp4_;
	GDBusConnection* _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
#line 512 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 512 "indicator.vala"
	g_return_if_fail (icon_name != NULL);
#line 513 "indicator.vala"
	changed = FALSE;
#line 514 "indicator.vala"
	_tmp0_ = self->priv->_icon_name;
#line 514 "indicator.vala"
	if (g_strcmp0 (_tmp0_, icon_name) != 0) {
#line 515 "indicator.vala"
		indicator_set_icon_name (self, icon_name);
#line 516 "indicator.vala"
		indicator_set_icon_vector (self, NULL);
#line 517 "indicator.vala"
		changed = TRUE;
#line 2516 "indicator.c"
	}
#line 519 "indicator.vala"
	_tmp1_ = self->priv->_icon_desc;
#line 519 "indicator.vala"
	if (g_strcmp0 (_tmp1_, icon_desc) != 0) {
#line 520 "indicator.vala"
		indicator_set_icon_desc (self, icon_desc);
#line 521 "indicator.vala"
		changed = TRUE;
#line 2526 "indicator.c"
	}
#line 523 "indicator.vala"
	if (!changed) {
#line 524 "indicator.vala"
		return;
#line 2532 "indicator.c"
	}
#line 531 "indicator.vala"
	g_object_get ((IBusService*) self, "connection", &_tmp3_, NULL);
#line 531 "indicator.vala"
	_tmp4_ = _tmp3_;
#line 531 "indicator.vala"
	_tmp5_ = _tmp4_;
#line 531 "indicator.vala"
	_tmp6_ = _tmp5_ == NULL;
#line 531 "indicator.vala"
	_g_object_unref0 (_tmp5_);
#line 531 "indicator.vala"
	if (_tmp6_) {
#line 531 "indicator.vala"
		_tmp2_ = TRUE;
#line 2548 "indicator.c"
	} else {
#line 531 "indicator.vala"
		_tmp2_ = !self->priv->m_registered;
#line 2552 "indicator.c"
	}
#line 531 "indicator.vala"
	if (_tmp2_) {
#line 532 "indicator.vala"
		return;
#line 2558 "indicator.c"
	}
	{
		GDBusConnection* _tmp7_;
		GDBusConnection* _tmp8_;
		GDBusConnection* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 534 "indicator.vala"
		g_object_get ((IBusService*) self, "connection", &_tmp7_, NULL);
#line 534 "indicator.vala"
		_tmp8_ = _tmp7_;
#line 534 "indicator.vala"
		_tmp9_ = _tmp8_;
#line 534 "indicator.vala"
		_tmp10_ = ibus_service_get_object_path ((IBusService*) self);
#line 534 "indicator.vala"
		_tmp11_ = _tmp10_;
#line 534 "indicator.vala"
		g_dbus_connection_emit_signal (_tmp9_, NULL, _tmp11_, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE, "NewIcon", NULL, &_inner_error0_);
#line 534 "indicator.vala"
		_g_object_unref0 (_tmp9_);
#line 534 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2582 "indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 533 "indicator.vala"
		e = _inner_error0_;
#line 533 "indicator.vala"
		_inner_error0_ = NULL;
#line 540 "indicator.vala"
		_tmp12_ = e;
#line 540 "indicator.vala"
		_tmp13_ = _tmp12_->message;
#line 540 "indicator.vala"
		g_warning ("indicator.vala:540: Unable to send signal for NewIcon: %s", _tmp13_);
#line 533 "indicator.vala"
		_g_error_free0 (e);
#line 2604 "indicator.c"
	}
	__finally0:
#line 533 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 533 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 533 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 533 "indicator.vala"
		return;
#line 2615 "indicator.c"
	}
}

void
indicator_set_cairo_image_surface_full (Indicator* self,
                                        cairo_surface_t* image,
                                        const gchar* icon_desc)
{
	gint width = 0;
	gint height = 0;
	gint stride = 0;
	guint8* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	GBytes* bytes = NULL;
	guint8* _tmp1_;
	gint _tmp1__length1;
	GBytes* _tmp2_;
	GVariant* bs = NULL;
	const GVariantType* _tmp3_;
	GBytes* _tmp4_;
	GVariant* _tmp5_;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp6_;
	GVariantType* _tmp7_;
	GVariantBuilder* _tmp8_;
	GVariantBuilder* _tmp9_;
	GVariantBuilder* _tmp10_;
	GVariantType* _tmp11_;
	GVariantType* _tmp12_;
	GVariantBuilder* _tmp13_;
	GVariantBuilder* _tmp14_;
	GVariantBuilder* _tmp15_;
	GVariant* _tmp16_;
	GVariantBuilder* _tmp17_;
	GVariantBuilder* _tmp18_;
	GVariant* _tmp19_;
	GVariant* _tmp20_;
	const gchar* _tmp21_;
	GDBusConnection* _tmp22_;
	GDBusConnection* _tmp23_;
	GDBusConnection* _tmp24_;
	gboolean _tmp25_;
	GError* _inner_error0_ = NULL;
#line 545 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 545 "indicator.vala"
	g_return_if_fail (image != NULL);
#line 547 "indicator.vala"
	width = cairo_image_surface_get_width (image);
#line 548 "indicator.vala"
	height = cairo_image_surface_get_height (image);
#line 549 "indicator.vala"
	stride = cairo_image_surface_get_stride (image);
#line 550 "indicator.vala"
	_tmp0_ = cairo_image_surface_get_data (image);
#line 550 "indicator.vala"
	data = (guint8*) _tmp0_;
#line 550 "indicator.vala"
	data_length1 = (-1 * sizeof (guchar)) / sizeof (guint8);
#line 550 "indicator.vala"
	_data_size_ = data_length1;
#line 551 "indicator.vala"
	data_length1 = stride * height;
#line 552 "indicator.vala"
	_tmp1_ = data;
#line 552 "indicator.vala"
	_tmp1__length1 = data_length1;
#line 552 "indicator.vala"
	_tmp2_ = g_bytes_new (_tmp1_, _tmp1__length1);
#line 552 "indicator.vala"
	bytes = _tmp2_;
#line 553 "indicator.vala"
	_tmp3_ = G_VARIANT_TYPE_BYTESTRING;
#line 553 "indicator.vala"
	_tmp4_ = bytes;
#line 553 "indicator.vala"
	_tmp5_ = g_variant_new_from_bytes (_tmp3_, _tmp4_, TRUE);
#line 553 "indicator.vala"
	g_variant_ref_sink (_tmp5_);
#line 553 "indicator.vala"
	bs = _tmp5_;
#line 557 "indicator.vala"
	_tmp6_ = g_variant_type_new ("a(iiay)");
#line 557 "indicator.vala"
	_tmp7_ = _tmp6_;
#line 557 "indicator.vala"
	_tmp8_ = g_variant_builder_new (_tmp7_);
#line 557 "indicator.vala"
	_tmp9_ = _tmp8_;
#line 557 "indicator.vala"
	_g_variant_type_free0 (_tmp7_);
#line 557 "indicator.vala"
	builder = _tmp9_;
#line 559 "indicator.vala"
	_tmp10_ = builder;
#line 559 "indicator.vala"
	_tmp11_ = g_variant_type_new ("(iiay)");
#line 559 "indicator.vala"
	_tmp12_ = _tmp11_;
#line 559 "indicator.vala"
	g_variant_builder_open (_tmp10_, _tmp12_);
#line 559 "indicator.vala"
	_g_variant_type_free0 (_tmp12_);
#line 560 "indicator.vala"
	_tmp13_ = builder;
#line 560 "indicator.vala"
	g_variant_builder_add (_tmp13_, "i", width, NULL);
#line 561 "indicator.vala"
	_tmp14_ = builder;
#line 561 "indicator.vala"
	g_variant_builder_add (_tmp14_, "i", height, NULL);
#line 562 "indicator.vala"
	_tmp15_ = builder;
#line 562 "indicator.vala"
	_tmp16_ = bs;
#line 562 "indicator.vala"
	g_variant_builder_add_value (_tmp15_, _tmp16_);
#line 563 "indicator.vala"
	_tmp17_ = builder;
#line 563 "indicator.vala"
	g_variant_builder_close (_tmp17_);
#line 564 "indicator.vala"
	_tmp18_ = builder;
#line 564 "indicator.vala"
	_tmp19_ = g_variant_new ("a(iiay)", _tmp18_, NULL);
#line 564 "indicator.vala"
	g_variant_ref_sink (_tmp19_);
#line 564 "indicator.vala"
	_tmp20_ = _tmp19_;
#line 564 "indicator.vala"
	indicator_set_icon_vector (self, _tmp20_);
#line 564 "indicator.vala"
	_g_variant_unref0 (_tmp20_);
#line 565 "indicator.vala"
	indicator_set_icon_name (self, "");
#line 567 "indicator.vala"
	_tmp21_ = self->priv->_icon_desc;
#line 567 "indicator.vala"
	if (g_strcmp0 (_tmp21_, icon_desc) != 0) {
#line 568 "indicator.vala"
		indicator_set_icon_desc (self, icon_desc);
#line 2759 "indicator.c"
	}
#line 575 "indicator.vala"
	g_object_get ((IBusService*) self, "connection", &_tmp22_, NULL);
#line 575 "indicator.vala"
	_tmp23_ = _tmp22_;
#line 575 "indicator.vala"
	_tmp24_ = _tmp23_;
#line 575 "indicator.vala"
	_tmp25_ = _tmp24_ == NULL;
#line 575 "indicator.vala"
	_g_object_unref0 (_tmp24_);
#line 575 "indicator.vala"
	if (_tmp25_) {
#line 576 "indicator.vala"
		_g_variant_builder_unref0 (builder);
#line 576 "indicator.vala"
		_g_variant_unref0 (bs);
#line 576 "indicator.vala"
		_g_bytes_unref0 (bytes);
#line 576 "indicator.vala"
		return;
#line 2781 "indicator.c"
	}
	{
		GDBusConnection* _tmp26_;
		GDBusConnection* _tmp27_;
		GDBusConnection* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 578 "indicator.vala"
		g_object_get ((IBusService*) self, "connection", &_tmp26_, NULL);
#line 578 "indicator.vala"
		_tmp27_ = _tmp26_;
#line 578 "indicator.vala"
		_tmp28_ = _tmp27_;
#line 578 "indicator.vala"
		_tmp29_ = ibus_service_get_object_path ((IBusService*) self);
#line 578 "indicator.vala"
		_tmp30_ = _tmp29_;
#line 578 "indicator.vala"
		g_dbus_connection_emit_signal (_tmp28_, NULL, _tmp30_, INDICATOR_NOTIFICATION_ITEM_DBUS_IFACE, "NewIcon", NULL, &_inner_error0_);
#line 578 "indicator.vala"
		_g_object_unref0 (_tmp28_);
#line 578 "indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2805 "indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
#line 577 "indicator.vala"
		e = _inner_error0_;
#line 577 "indicator.vala"
		_inner_error0_ = NULL;
#line 584 "indicator.vala"
		_tmp31_ = e;
#line 584 "indicator.vala"
		_tmp32_ = _tmp31_->message;
#line 584 "indicator.vala"
		g_warning ("indicator.vala:584: Unable to send signal for NewIcon: %s", _tmp32_);
#line 577 "indicator.vala"
		_g_error_free0 (e);
#line 2827 "indicator.c"
	}
	__finally0:
#line 577 "indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "indicator.vala"
		_g_variant_builder_unref0 (builder);
#line 577 "indicator.vala"
		_g_variant_unref0 (bs);
#line 577 "indicator.vala"
		_g_bytes_unref0 (bytes);
#line 577 "indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 577 "indicator.vala"
		g_clear_error (&_inner_error0_);
#line 577 "indicator.vala"
		return;
#line 2844 "indicator.c"
	}
#line 545 "indicator.vala"
	_g_variant_builder_unref0 (builder);
#line 545 "indicator.vala"
	_g_variant_unref0 (bs);
#line 545 "indicator.vala"
	_g_bytes_unref0 (bytes);
#line 2852 "indicator.c"
}

void
indicator_set_menu (Indicator* self,
                    GtkMenu* menu)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkMenu* _tmp2_;
	DbusmenuServer* _tmp3_;
	DbusmenuMenuitem* root = NULL;
	DbusmenuMenuitem* _tmp9_;
	DbusmenuServer* _tmp10_;
	DbusmenuMenuitem* _tmp11_;
#line 589 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 589 "indicator.vala"
	g_return_if_fail (menu != NULL);
#line 590 "indicator.vala"
	_tmp0_ = ibus_service_get_object_path ((IBusService*) self);
#line 590 "indicator.vala"
	_tmp1_ = _tmp0_;
#line 590 "indicator.vala"
	if (_tmp1_ == NULL) {
#line 591 "indicator.vala"
		return;
#line 2879 "indicator.c"
	}
#line 592 "indicator.vala"
	_tmp2_ = _g_object_ref0 (menu);
#line 592 "indicator.vala"
	_g_object_unref0 (self->priv->m_menu);
#line 592 "indicator.vala"
	self->priv->m_menu = _tmp2_;
#line 593 "indicator.vala"
	_tmp3_ = self->priv->m_dbusmenu_server;
#line 593 "indicator.vala"
	if (_tmp3_ == NULL) {
#line 2891 "indicator.c"
		gchar* path = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		DbusmenuServer* _tmp8_;
#line 594 "indicator.vala"
		_tmp4_ = ibus_service_get_object_path ((IBusService*) self);
#line 594 "indicator.vala"
		_tmp5_ = _tmp4_;
#line 594 "indicator.vala"
		_tmp6_ = g_strconcat (_tmp5_, "/Menu", NULL);
#line 594 "indicator.vala"
		path = _tmp6_;
#line 595 "indicator.vala"
		_tmp7_ = path;
#line 595 "indicator.vala"
		_tmp8_ = dbusmenu_server_new (_tmp7_);
#line 595 "indicator.vala"
		_g_object_unref0 (self->priv->m_dbusmenu_server);
#line 595 "indicator.vala"
		self->priv->m_dbusmenu_server = _tmp8_;
#line 593 "indicator.vala"
		_g_free0 (path);
#line 2916 "indicator.c"
	}
#line 597 "indicator.vala"
	_tmp9_ = dbusmenu_gtk_parse_menu_structure ((GtkWidget*) menu);
#line 597 "indicator.vala"
	root = _tmp9_;
#line 598 "indicator.vala"
	_tmp10_ = self->priv->m_dbusmenu_server;
#line 598 "indicator.vala"
	_tmp11_ = root;
#line 598 "indicator.vala"
	dbusmenu_server_set_root (_tmp10_, _tmp11_);
#line 599 "indicator.vala"
	indicator_check_connect (self);
#line 589 "indicator.vala"
	_g_object_unref0 (root);
#line 2932 "indicator.c"
}

void
indicator_position_context_menu (Indicator* self,
                                 GtkMenu* menu,
                                 gint* x,
                                 gint* y,
                                 gboolean* push_in)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
#line 603 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 603 "indicator.vala"
	g_return_if_fail (menu != NULL);
#line 607 "indicator.vala"
	_vala_x = self->priv->m_context_menu_x;
#line 608 "indicator.vala"
	_vala_y = self->priv->m_context_menu_y;
#line 609 "indicator.vala"
	_vala_push_in = FALSE;
#line 603 "indicator.vala"
	if (x) {
#line 603 "indicator.vala"
		*x = _vala_x;
#line 2959 "indicator.c"
	}
#line 603 "indicator.vala"
	if (y) {
#line 603 "indicator.vala"
		*y = _vala_y;
#line 2965 "indicator.c"
	}
#line 603 "indicator.vala"
	if (push_in) {
#line 603 "indicator.vala"
		*push_in = _vala_push_in;
#line 2971 "indicator.c"
	}
}

void
indicator_position_activate_menu (Indicator* self,
                                  GtkMenu* menu,
                                  gint* x,
                                  gint* y,
                                  gboolean* push_in)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
#line 613 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 613 "indicator.vala"
	g_return_if_fail (menu != NULL);
#line 617 "indicator.vala"
	_vala_x = self->priv->m_activate_menu_x;
#line 618 "indicator.vala"
	_vala_y = self->priv->m_activate_menu_y;
#line 619 "indicator.vala"
	_vala_push_in = FALSE;
#line 613 "indicator.vala"
	if (x) {
#line 613 "indicator.vala"
		*x = _vala_x;
#line 2999 "indicator.c"
	}
#line 613 "indicator.vala"
	if (y) {
#line 613 "indicator.vala"
		*y = _vala_y;
#line 3005 "indicator.c"
	}
#line 613 "indicator.vala"
	if (push_in) {
#line 613 "indicator.vala"
		*push_in = _vala_push_in;
#line 3011 "indicator.c"
	}
}

/**
     * unregister_connection:
     *
     * "Destroy" dbus method is not called for the indicator's connection
     * when panel's connection is disconnected because the dbus connection
     * is a shared session bus so need to call
     * g_dbus_connection_unregister_object() by manual here
     * so that g_object_unref(m_panel) will be called later with an idle method,
     * which was assigned in the arguments of
     * g_dbus_connection_register_object()
     */
void
indicator_unregister_connection (Indicator* self)
{
	GDBusConnection* _tmp0_;
#line 634 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 635 "indicator.vala"
	_tmp0_ = ibus_service_get_connection ((IBusService*) self);
#line 635 "indicator.vala"
	ibus_service_unregister ((IBusService*) self, _tmp0_);
#line 3036 "indicator.c"
}

const gchar*
indicator_get_id (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "indicator.vala"
	_tmp0_ = self->priv->_id;
#line 36 "indicator.vala"
	result = _tmp0_;
#line 36 "indicator.vala"
	return result;
#line 3052 "indicator.c"
}

static void
indicator_set_id (Indicator* self,
                  const gchar* value)
{
	gchar* old_value;
#line 36 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 36 "indicator.vala"
	old_value = indicator_get_id (self);
#line 36 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3066 "indicator.c"
		gchar* _tmp0_;
#line 36 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 36 "indicator.vala"
		_g_free0 (self->priv->_id);
#line 36 "indicator.vala"
		self->priv->_id = _tmp0_;
#line 36 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ID_PROPERTY]);
#line 3076 "indicator.c"
	}
}

const gchar*
indicator_get_category_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "indicator.vala"
	_tmp0_ = self->priv->_category_s;
#line 37 "indicator.vala"
	result = _tmp0_;
#line 37 "indicator.vala"
	return result;
#line 3093 "indicator.c"
}

static void
indicator_set_category_s (Indicator* self,
                          const gchar* value)
{
	gchar* old_value;
#line 37 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 37 "indicator.vala"
	old_value = indicator_get_category_s (self);
#line 37 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3107 "indicator.c"
		gchar* _tmp0_;
#line 37 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 37 "indicator.vala"
		_g_free0 (self->priv->_category_s);
#line 37 "indicator.vala"
		self->priv->_category_s = _tmp0_;
#line 37 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_CATEGORY_S_PROPERTY]);
#line 3117 "indicator.c"
	}
}

const gchar*
indicator_get_status_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "indicator.vala"
	_tmp0_ = self->priv->_status_s;
#line 38 "indicator.vala"
	result = _tmp0_;
#line 38 "indicator.vala"
	return result;
#line 3134 "indicator.c"
}

void
indicator_set_status_s (Indicator* self,
                        const gchar* value)
{
	gchar* old_value;
#line 38 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 38 "indicator.vala"
	old_value = indicator_get_status_s (self);
#line 38 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3148 "indicator.c"
		gchar* _tmp0_;
#line 38 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 38 "indicator.vala"
		_g_free0 (self->priv->_status_s);
#line 38 "indicator.vala"
		self->priv->_status_s = _tmp0_;
#line 38 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_STATUS_S_PROPERTY]);
#line 3158 "indicator.c"
	}
}

const gchar*
indicator_get_icon_name (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "indicator.vala"
	_tmp0_ = self->priv->_icon_name;
#line 39 "indicator.vala"
	result = _tmp0_;
#line 39 "indicator.vala"
	return result;
#line 3175 "indicator.c"
}

void
indicator_set_icon_name (Indicator* self,
                         const gchar* value)
{
	gchar* old_value;
#line 39 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 39 "indicator.vala"
	old_value = indicator_get_icon_name (self);
#line 39 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3189 "indicator.c"
		gchar* _tmp0_;
#line 39 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 39 "indicator.vala"
		_g_free0 (self->priv->_icon_name);
#line 39 "indicator.vala"
		self->priv->_icon_name = _tmp0_;
#line 39 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_NAME_PROPERTY]);
#line 3199 "indicator.c"
	}
}

const gchar*
indicator_get_icon_desc (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "indicator.vala"
	_tmp0_ = self->priv->_icon_desc;
#line 40 "indicator.vala"
	result = _tmp0_;
#line 40 "indicator.vala"
	return result;
#line 3216 "indicator.c"
}

void
indicator_set_icon_desc (Indicator* self,
                         const gchar* value)
{
	gchar* old_value;
#line 40 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 40 "indicator.vala"
	old_value = indicator_get_icon_desc (self);
#line 40 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3230 "indicator.c"
		gchar* _tmp0_;
#line 40 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 40 "indicator.vala"
		_g_free0 (self->priv->_icon_desc);
#line 40 "indicator.vala"
		self->priv->_icon_desc = _tmp0_;
#line 40 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_DESC_PROPERTY]);
#line 3240 "indicator.c"
	}
}

const gchar*
indicator_get_attention_icon_name (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_name;
#line 41 "indicator.vala"
	result = _tmp0_;
#line 41 "indicator.vala"
	return result;
#line 3257 "indicator.c"
}

void
indicator_set_attention_icon_name (Indicator* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 41 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 41 "indicator.vala"
	old_value = indicator_get_attention_icon_name (self);
#line 41 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3271 "indicator.c"
		gchar* _tmp0_;
#line 41 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 41 "indicator.vala"
		_g_free0 (self->priv->_attention_icon_name);
#line 41 "indicator.vala"
		self->priv->_attention_icon_name = _tmp0_;
#line 41 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ATTENTION_ICON_NAME_PROPERTY]);
#line 3281 "indicator.c"
	}
}

const gchar*
indicator_get_attention_icon_desc (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "indicator.vala"
	_tmp0_ = self->priv->_attention_icon_desc;
#line 42 "indicator.vala"
	result = _tmp0_;
#line 42 "indicator.vala"
	return result;
#line 3298 "indicator.c"
}

void
indicator_set_attention_icon_desc (Indicator* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 42 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 42 "indicator.vala"
	old_value = indicator_get_attention_icon_desc (self);
#line 42 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3312 "indicator.c"
		gchar* _tmp0_;
#line 42 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 42 "indicator.vala"
		_g_free0 (self->priv->_attention_icon_desc);
#line 42 "indicator.vala"
		self->priv->_attention_icon_desc = _tmp0_;
#line 42 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ATTENTION_ICON_DESC_PROPERTY]);
#line 3322 "indicator.c"
	}
}

const gchar*
indicator_get_title (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "indicator.vala"
	_tmp0_ = self->priv->_title;
#line 43 "indicator.vala"
	result = _tmp0_;
#line 43 "indicator.vala"
	return result;
#line 3339 "indicator.c"
}

void
indicator_set_title (Indicator* self,
                     const gchar* value)
{
	gchar* old_value;
#line 43 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 43 "indicator.vala"
	old_value = indicator_get_title (self);
#line 43 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3353 "indicator.c"
		gchar* _tmp0_;
#line 43 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 43 "indicator.vala"
		_g_free0 (self->priv->_title);
#line 43 "indicator.vala"
		self->priv->_title = _tmp0_;
#line 43 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_TITLE_PROPERTY]);
#line 3363 "indicator.c"
	}
}

const gchar*
indicator_get_icon_theme_path (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "indicator.vala"
	_tmp0_ = self->priv->_icon_theme_path;
#line 44 "indicator.vala"
	result = _tmp0_;
#line 44 "indicator.vala"
	return result;
#line 3380 "indicator.c"
}

void
indicator_set_icon_theme_path (Indicator* self,
                               const gchar* value)
{
	gchar* old_value;
#line 44 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 44 "indicator.vala"
	old_value = indicator_get_icon_theme_path (self);
#line 44 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3394 "indicator.c"
		gchar* _tmp0_;
#line 44 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 44 "indicator.vala"
		_g_free0 (self->priv->_icon_theme_path);
#line 44 "indicator.vala"
		self->priv->_icon_theme_path = _tmp0_;
#line 44 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_THEME_PATH_PROPERTY]);
#line 3404 "indicator.c"
	}
}

gboolean
indicator_get_connected (Indicator* self)
{
	gboolean result;
#line 45 "indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "indicator.vala"
	result = self->priv->_connected;
#line 45 "indicator.vala"
	return result;
#line 3418 "indicator.c"
}

void
indicator_set_connected (Indicator* self,
                         gboolean value)
{
	gboolean old_value;
#line 45 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 45 "indicator.vala"
	old_value = indicator_get_connected (self);
#line 45 "indicator.vala"
	if (old_value != value) {
#line 45 "indicator.vala"
		self->priv->_connected = value;
#line 45 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_CONNECTED_PROPERTY]);
#line 3436 "indicator.c"
	}
}

const gchar*
indicator_get_label_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "indicator.vala"
	_tmp0_ = self->priv->_label_s;
#line 46 "indicator.vala"
	result = _tmp0_;
#line 46 "indicator.vala"
	return result;
#line 3453 "indicator.c"
}

void
indicator_set_label_s (Indicator* self,
                       const gchar* value)
{
	gchar* old_value;
#line 46 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 46 "indicator.vala"
	old_value = indicator_get_label_s (self);
#line 46 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3467 "indicator.c"
		gchar* _tmp0_;
#line 46 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 46 "indicator.vala"
		_g_free0 (self->priv->_label_s);
#line 46 "indicator.vala"
		self->priv->_label_s = _tmp0_;
#line 46 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_LABEL_S_PROPERTY]);
#line 3477 "indicator.c"
	}
}

const gchar*
indicator_get_label_guide_s (Indicator* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "indicator.vala"
	_tmp0_ = self->priv->_label_guide_s;
#line 47 "indicator.vala"
	result = _tmp0_;
#line 47 "indicator.vala"
	return result;
#line 3494 "indicator.c"
}

void
indicator_set_label_guide_s (Indicator* self,
                             const gchar* value)
{
	gchar* old_value;
#line 47 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 47 "indicator.vala"
	old_value = indicator_get_label_guide_s (self);
#line 47 "indicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3508 "indicator.c"
		gchar* _tmp0_;
#line 47 "indicator.vala"
		_tmp0_ = g_strdup (value);
#line 47 "indicator.vala"
		_g_free0 (self->priv->_label_guide_s);
#line 47 "indicator.vala"
		self->priv->_label_guide_s = _tmp0_;
#line 47 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_LABEL_GUIDE_S_PROPERTY]);
#line 3518 "indicator.c"
	}
}

guint32
indicator_get_ordering_index (Indicator* self)
{
	guint32 result;
#line 48 "indicator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 48 "indicator.vala"
	result = self->priv->_ordering_index;
#line 48 "indicator.vala"
	return result;
#line 3532 "indicator.c"
}

void
indicator_set_ordering_index (Indicator* self,
                              guint32 value)
{
	guint32 old_value;
#line 48 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 48 "indicator.vala"
	old_value = indicator_get_ordering_index (self);
#line 48 "indicator.vala"
	if (old_value != value) {
#line 48 "indicator.vala"
		self->priv->_ordering_index = value;
#line 48 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ORDERING_INDEX_PROPERTY]);
#line 3550 "indicator.c"
	}
}

GVariant*
indicator_get_icon_vector (Indicator* self)
{
	GVariant* result;
	GVariant* _tmp0_;
#line 49 "indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "indicator.vala"
	_tmp0_ = self->priv->_icon_vector;
#line 49 "indicator.vala"
	result = _tmp0_;
#line 49 "indicator.vala"
	return result;
#line 3567 "indicator.c"
}

void
indicator_set_icon_vector (Indicator* self,
                           GVariant* value)
{
	GVariant* old_value;
#line 49 "indicator.vala"
	g_return_if_fail (self != NULL);
#line 49 "indicator.vala"
	old_value = indicator_get_icon_vector (self);
#line 49 "indicator.vala"
	if (old_value != value) {
#line 3581 "indicator.c"
		GVariant* _tmp0_;
#line 49 "indicator.vala"
		_tmp0_ = _g_variant_ref0 (value);
#line 49 "indicator.vala"
		_g_variant_unref0 (self->priv->_icon_vector);
#line 49 "indicator.vala"
		self->priv->_icon_vector = _tmp0_;
#line 49 "indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, indicator_properties[INDICATOR_ICON_VECTOR_PROPERTY]);
#line 3591 "indicator.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_INT_OBJECT_UINT_UINT (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_OBJECT_UINT_UINT) (gpointer data1, gint arg_1, gint arg_2, gpointer arg_3, guint arg_4, guint arg_5, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_OBJECT_UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "indicator.vala"
	g_return_if_fail (n_param_values == 6);
#line 34 "indicator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "indicator.vala"
		data1 = closure->data;
#line 34 "indicator.vala"
		data2 = param_values->data[0].v_pointer;
#line 3617 "indicator.c"
	} else {
#line 34 "indicator.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "indicator.vala"
		data2 = closure->data;
#line 3623 "indicator.c"
	}
#line 34 "indicator.vala"
	callback = (GMarshalFunc_VOID__INT_INT_OBJECT_UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 34 "indicator.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_object (param_values + 3), g_value_get_uint (param_values + 4), g_value_get_uint (param_values + 5), data2);
#line 3629 "indicator.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_OBJECT) (gpointer data1, gint arg_1, gint arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "indicator.vala"
	g_return_if_fail (n_param_values == 4);
#line 34 "indicator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "indicator.vala"
		data1 = closure->data;
#line 34 "indicator.vala"
		data2 = param_values->data[0].v_pointer;
#line 3654 "indicator.c"
	} else {
#line 34 "indicator.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "indicator.vala"
		data2 = closure->data;
#line 3660 "indicator.c"
	}
#line 34 "indicator.vala"
	callback = (GMarshalFunc_VOID__INT_INT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 34 "indicator.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 3666 "indicator.c"
}

static void
indicator_class_init (IndicatorClass * klass,
                      gpointer klass_data)
{
#line 34 "indicator.vala"
	indicator_parent_class = g_type_class_peek_parent (klass);
#line 34 "indicator.vala"
	g_type_class_adjust_private_offset (klass, &Indicator_private_offset);
#line 34 "indicator.vala"
	((IBusServiceClass *) klass)->service_method_call = (void (*) (IBusService*, GDBusConnection*, const gchar*, const gchar*, const gchar*, const gchar*, GVariant*, GDBusMethodInvocation*)) indicator_real_service_method_call;
#line 34 "indicator.vala"
	((IBusServiceClass *) klass)->service_get_property = (GVariant* (*) (IBusService*, GDBusConnection*, const gchar*, const gchar*, const gchar*, const gchar*, GError**)) indicator_real_service_get_property;
#line 34 "indicator.vala"
	((IBusServiceClass *) klass)->service_set_property = (gboolean (*) (IBusService*, GDBusConnection*, const gchar*, const gchar*, const gchar*, const gchar*, GVariant*, GError**)) indicator_real_service_set_property;
#line 34 "indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_indicator_get_property;
#line 34 "indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_indicator_set_property;
#line 34 "indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = indicator_finalize;
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ID_PROPERTY, indicator_properties[INDICATOR_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_CATEGORY_S_PROPERTY, indicator_properties[INDICATOR_CATEGORY_S_PROPERTY] = g_param_spec_string ("category-s", "category-s", "category-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_STATUS_S_PROPERTY, indicator_properties[INDICATOR_STATUS_S_PROPERTY] = g_param_spec_string ("status-s", "status-s", "status-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_NAME_PROPERTY, indicator_properties[INDICATOR_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_DESC_PROPERTY, indicator_properties[INDICATOR_ICON_DESC_PROPERTY] = g_param_spec_string ("icon-desc", "icon-desc", "icon-desc", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ATTENTION_ICON_NAME_PROPERTY, indicator_properties[INDICATOR_ATTENTION_ICON_NAME_PROPERTY] = g_param_spec_string ("attention-icon-name", "attention-icon-name", "attention-icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ATTENTION_ICON_DESC_PROPERTY, indicator_properties[INDICATOR_ATTENTION_ICON_DESC_PROPERTY] = g_param_spec_string ("attention-icon-desc", "attention-icon-desc", "attention-icon-desc", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_TITLE_PROPERTY, indicator_properties[INDICATOR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_THEME_PATH_PROPERTY, indicator_properties[INDICATOR_ICON_THEME_PATH_PROPERTY] = g_param_spec_string ("icon-theme-path", "icon-theme-path", "icon-theme-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_CONNECTED_PROPERTY, indicator_properties[INDICATOR_CONNECTED_PROPERTY] = g_param_spec_boolean ("connected", "connected", "connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_LABEL_S_PROPERTY, indicator_properties[INDICATOR_LABEL_S_PROPERTY] = g_param_spec_string ("label-s", "label-s", "label-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_LABEL_GUIDE_S_PROPERTY, indicator_properties[INDICATOR_LABEL_GUIDE_S_PROPERTY] = g_param_spec_string ("label-guide-s", "label-guide-s", "label-guide-s", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ORDERING_INDEX_PROPERTY, indicator_properties[INDICATOR_ORDERING_INDEX_PROPERTY] = g_param_spec_uint ("ordering-index", "ordering-index", "ordering-index", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ICON_VECTOR_PROPERTY, indicator_properties[INDICATOR_ICON_VECTOR_PROPERTY] = g_param_spec_variant ("icon-vector", "icon-vector", "icon-vector", G_VARIANT_TYPE_ANY, NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "indicator.vala"
	indicator_signals[INDICATOR_CONTEXT_MENU_SIGNAL] = g_signal_new ("context-menu", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_OBJECT_UINT_UINT, G_TYPE_NONE, 5, G_TYPE_INT, G_TYPE_INT, gdk_window_get_type (), G_TYPE_UINT, G_TYPE_UINT);
#line 34 "indicator.vala"
	indicator_signals[INDICATOR_ACTIVATE_SIGNAL] = g_signal_new ("activate", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_OBJECT, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_INT, gdk_window_get_type ());
#line 34 "indicator.vala"
	indicator_signals[INDICATOR_SECONDARY_ACTIVATE_SIGNAL] = g_signal_new ("secondary-activate", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "indicator.vala"
	indicator_signals[INDICATOR_REGISTERED_STATUS_NOTIFIER_ITEM_SIGNAL] = g_signal_new ("registered-status-notifier-item", TYPE_INDICATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3725 "indicator.c"
}

static void
indicator_instance_init (Indicator * self,
                         gpointer klass)
{
#line 34 "indicator.vala"
	self->priv = indicator_get_instance_private (self);
#line 3734 "indicator.c"
}

static void
indicator_finalize (GObject * obj)
{
	Indicator * self;
#line 34 "indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INDICATOR, Indicator);
#line 36 "indicator.vala"
	_g_free0 (self->priv->_id);
#line 37 "indicator.vala"
	_g_free0 (self->priv->_category_s);
#line 38 "indicator.vala"
	_g_free0 (self->priv->_status_s);
#line 39 "indicator.vala"
	_g_free0 (self->priv->_icon_name);
#line 40 "indicator.vala"
	_g_free0 (self->priv->_icon_desc);
#line 41 "indicator.vala"
	_g_free0 (self->priv->_attention_icon_name);
#line 42 "indicator.vala"
	_g_free0 (self->priv->_attention_icon_desc);
#line 43 "indicator.vala"
	_g_free0 (self->priv->_title);
#line 44 "indicator.vala"
	_g_free0 (self->priv->_icon_theme_path);
#line 46 "indicator.vala"
	_g_free0 (self->priv->_label_s);
#line 47 "indicator.vala"
	_g_free0 (self->priv->_label_guide_s);
#line 49 "indicator.vala"
	_g_variant_unref0 (self->priv->_icon_vector);
#line 95 "indicator.vala"
	_g_dbus_node_info_unref0 (self->priv->m_watcher_node_info);
#line 98 "indicator.vala"
	_g_object_unref0 (self->priv->m_proxy);
#line 103 "indicator.vala"
	_g_object_unref0 (self->priv->m_indicator_window);
#line 104 "indicator.vala"
	_g_object_unref0 (self->priv->m_menu);
#line 105 "indicator.vala"
	_g_object_unref0 (self->priv->m_dbusmenu_server);
#line 34 "indicator.vala"
	G_OBJECT_CLASS (indicator_parent_class)->finalize (obj);
#line 3779 "indicator.c"
}

static GType
indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Indicator), 0, (GInstanceInitFunc) indicator_instance_init, NULL };
	GType indicator_type_id;
	indicator_type_id = g_type_register_static (ibus_service_get_type (), "Indicator", &g_define_type_info, 0);
	Indicator_private_offset = g_type_add_instance_private (indicator_type_id, sizeof (IndicatorPrivate));
	return indicator_type_id;
}

GType
indicator_get_type (void)
{
	static volatile gsize indicator_type_id__once = 0;
	if (g_once_init_enter (&indicator_type_id__once)) {
		GType indicator_type_id;
		indicator_type_id = indicator_get_type_once ();
		g_once_init_leave (&indicator_type_id__once, indicator_type_id);
	}
	return indicator_type_id__once;
}

static void
_vala_indicator_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Indicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INDICATOR, Indicator);
#line 34 "indicator.vala"
	switch (property_id) {
#line 34 "indicator.vala"
		case INDICATOR_ID_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_id (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_CATEGORY_S_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_category_s (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_STATUS_S_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_status_s (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_NAME_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_icon_name (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_DESC_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_icon_desc (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_NAME_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_attention_icon_name (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_DESC_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_attention_icon_desc (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_TITLE_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_title (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_THEME_PATH_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_icon_theme_path (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_CONNECTED_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_boolean (value, indicator_get_connected (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_LABEL_S_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_label_s (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_LABEL_GUIDE_S_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_string (value, indicator_get_label_guide_s (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ORDERING_INDEX_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_uint (value, indicator_get_ordering_index (self));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_VECTOR_PROPERTY:
#line 34 "indicator.vala"
		g_value_set_variant (value, indicator_get_icon_vector (self));
#line 34 "indicator.vala"
		break;
#line 3898 "indicator.c"
		default:
#line 34 "indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "indicator.vala"
		break;
#line 3904 "indicator.c"
	}
}

static void
_vala_indicator_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Indicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INDICATOR, Indicator);
#line 34 "indicator.vala"
	switch (property_id) {
#line 34 "indicator.vala"
		case INDICATOR_ID_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_id (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_CATEGORY_S_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_category_s (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_STATUS_S_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_status_s (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_NAME_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_icon_name (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_DESC_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_icon_desc (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_NAME_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_attention_icon_name (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ATTENTION_ICON_DESC_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_attention_icon_desc (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_TITLE_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_title (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_THEME_PATH_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_icon_theme_path (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_CONNECTED_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_connected (self, g_value_get_boolean (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_LABEL_S_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_label_s (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_LABEL_GUIDE_S_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_label_guide_s (self, g_value_get_string (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ORDERING_INDEX_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_ordering_index (self, g_value_get_uint (value));
#line 34 "indicator.vala"
		break;
#line 34 "indicator.vala"
		case INDICATOR_ICON_VECTOR_PROPERTY:
#line 34 "indicator.vala"
		indicator_set_icon_vector (self, g_value_get_variant (value));
#line 34 "indicator.vala"
		break;
#line 4002 "indicator.c"
		default:
#line 34 "indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "indicator.vala"
		break;
#line 4008 "indicator.c"
	}
}

